unit DelphPxy;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils;

const
  { Stub classname }
  DELPHI_STUB = 'TDelphiStub';

  { Stub names for Delphi 1.0 and 2.0 }
  DELPHI_10 = 'Delphi 1.0';
  DELPHI_20 = 'Delphi 2.0';
  DELPHI_30 = 'Delphi 3.0';

  { Stub commands }
  SHOW_CLASS_HELP = 'H';
  STUB_NAME       = 'N';
  RELOAD_FILE     = 'R';
  SYNTAX_CHECK    = 'S';

function DelphiLoaded: Boolean;

function Delphi1Loaded: Boolean;

function Delphi2Loaded: Boolean;

function Delphi3Loaded: Boolean;

procedure SendCommand( StubName: PChar; CmdCode: Char; const CmdMsg: string);

procedure BroadCastCommand( CmdCode: Char; const CmdMsg: string);

implementation

function DelphiLoaded: Boolean;
begin
  Result := Delphi1Loaded or Delphi2Loaded or Delphi3Loaded;
end;

function Delphi1Loaded: Boolean;
begin
  Result := FindWindow( DELPHI_STUB, DELPHI_10) <> 0;
end;

function Delphi2Loaded: Boolean;
begin
  Result := FindWindow( DELPHI_STUB, DELPHI_20) <> 0;
end;

function Delphi3Loaded: Boolean;
begin
  Result := FindWindow( DELPHI_STUB, DELPHI_30) <> 0;
end;

procedure SendCommand( StubName: PChar; CmdCode: Char; const CmdMsg: string);
var
  CmdBuf: PChar;
  DelphiStub: HWnd;
begin
  CmdBuf := StrAlloc(257);
  try
    CmdBuf[0] := CmdCode;
    CmdBuf[1] := '@';
    StrPCopy( @CmdBuf[2], CmdMsg);
    DelphiStub := FindWindow( DELPHI_STUB, StubName);
    if DelphiStub <> 0 then SendMessage( DelphiStub, WM_SETTEXT, 0, LongInt(CmdBuf));
  finally
    StrDispose( CmdBuf);
  end;
end;

procedure BroadCastCommand( CmdCode: Char; const CmdMsg: string);
begin
  SendCommand( DELPHI_30, CmdCode, CmdMsg);
  SendCommand( DELPHI_20, CmdCode, CmdMsg);
  SendCommand( DELPHI_10, CmdCode, CmdMsg);
end;

end.
