
{                                                                              }
{ TIB_BDATASET                                                                 }
{                                                                              }

  TIB_BDataSet = class( TIB_DataSet )
  private
    FCurrentCursor: TIB_Cursor;
    FBufferCursor: TIB_Cursor;
    FBufferList: TIB_BufferList;
    FBufferRowNum: longint;
    FBufferNode: PIB_BufferNode;
    FRowNum: longint;
    FRowCount: longint;
    FHaveCursor: boolean;
    FSQLKeys: TStrings;
    FClearSQLKeys: boolean;
  protected
    procedure SetSQLKeys( ASQLKeys: TStrings ); virtual;
  { Inherited Property Access Methods }
    procedure SetIB_Connection( AValue: TIB_Connection ); override;
    procedure SetIB_Transaction( AValue: TIB_Transaction ); override;
    function GetCanEdit: boolean; override;
    function GetCanInsert: boolean; override;
    function GetCanDelete: boolean; override;
    function GetOutputRow: TIB_Row; override;
    function GetRowNum: longint; override;
    procedure SetRowNum( AValue: longint ); override;
    function GetUnidirectional: boolean; override;
    function GetBOF: boolean; override;
    function GetEOF: boolean; override;
  { Property Access Methods }
    function GetBufferRow: TIB_Row; override;
    function GetBufferRowNum: longint; override;
    procedure SetBufferRowNum( AValue: longint ); override;
    function GetBufferEOF: boolean; override;
    function GetBufferBOF: boolean; override;
    function GetBufferRowCount: longint; override;
    function GetBufferHasEOF: boolean; override;
    function GetKeysExist: boolean;
    function GetKeyCount: integer;
  { System Methods }
    procedure SysPrepareSQL; override;
    procedure SysUpdateDescriptors; override;
    procedure SysAfterUnprepare; override;
    procedure SysAfterFetchCursorRow; override;
    procedure SysAfterFetchCursorEOF; override;
    procedure SysAfterClose; override;
    procedure SysFirstRow; override;
    procedure SysMoveByRow( IncRows: longint ); override;
    procedure SysLastRow; override;
    procedure SysEditCursorRow; override;
    procedure SysInsertCursorRow; override;
    procedure SysDeleteCursorRow; override;
    procedure SysEditRow; override;
    procedure SysInsertRow; override;
    procedure SysDeleteRow; override;
    procedure SysAfterInsert; override;
    procedure SysCancelInsertedRow; override;
    procedure SysExecParentLinks; override;
  protected
    procedure SysScroll( NeedCursor: boolean );
    procedure SysBufferNode( Node:  PIB_BufferNode );
    procedure SysCacheRecord( Node: PIB_BufferNode; Row: TIB_Row );
    procedure SysUpdateKeyData; 
    property HaveCursor: boolean read FHaveCursor;
    property KeysExist: boolean read GetKeysExist;
    property ClearSQLKeys: boolean read FClearSQLKeys;
    property BufferNode: PIB_BufferNode read FBufferNode;
  public
    constructor Create( AOwner: TComponent ); override;
    destructor Destroy; override;
    property IsRowLocked;
    property SQLKeys: TStrings read FSQLKeys write SetSQLKeys;
  end;  { TIB_BDataSet }

// INT_IB_Buffer
// IMP_IB_BDataSet
