
{                                                                              }
{ TIB_Buffer                                                                   }
{                                                                              }

  PIB_BufferNode = ^TIB_BufferNode;
  TIB_BufferNode = record
    Prev, Next: PIB_BufferNode;
    KeyData: Pointer;
    RecordLen: integer;
    RecordData: Pointer;
  end;

  PIB_InsertedNode = ^TIB_InsertedNode;
  TIB_InsertedNode = record
    Next: PIB_InsertedNode;
    Data: PIB_BufferNode;
  end;

  PIB_Buffer = ^TIB_Buffer; 
  TIB_Buffer = record
    Position: longint;
    KeyData: pointer;
    ListNode: PIB_BufferNode;
  end;

  TIB_BufferList = class
  private
    FKeyDataLength: word;
    FRecordDataLength: word;
    FItemCount: longint;
    FFreeCount: longint;
    FInsertCount: longint;
    FDeleteCount: longint;
    FListHead,
    FListTail: TIB_BufferNode;
    FInsertedList: PIB_InsertedNode;
    FFreeList,
    FCurrent: PIB_BufferNode;
    FPosition: longint;
    FNewKeyDataLength,
    FNewRecordDataLength: integer;
  { Property Access Methods }
    procedure SetPosition( AValue: longint );
    function GetBOF: boolean;
    function GetEOF: boolean;
    function GetIsEmpty: boolean;
  protected
  { Utility Methods }
    procedure Initialize;
    function CreateNode: PIB_BufferNode;
    procedure DestroyNode( AValue: PIB_BufferNode );
    function GetNode: PIB_BufferNode;
    procedure FreeNode( AValue: PIB_BufferNode );
    procedure ClearInsertedList;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    procedure Update( NewKeyDataLength, NewRecordDataLength: integer );
    function Add: PIB_BufferNode;
    procedure Remove( Pos: longint );
    procedure RemoveAll;
    function Append( var PNewBuffer: PIB_BufferNode ): longint;
    function Insert: PIB_BufferNode;
    procedure Delete;
    procedure Clear;
//  function PositionOf( var AIB_Buffer: TIB_Buffer ): longint;
    function BufferOf( Pos: longint ): TIB_Buffer;
  { Properties }
    property BOF: boolean read GetBOF;
    property EOF: boolean read GetEOF;
    property IsEmpty: boolean read GetIsEmpty;
    property Position: longint read FPosition write SetPosition;
    property Current: PIB_BufferNode read FCurrent;
    property InsertedList: PIB_InsertedNode read FInsertedList;
    property ItemCount: longint read FItemCount;
    property FreeCount: longint read FFreeCount;
    property InsertCount: longint read FInsertCount;
    property DeleteCount: longint read FDeleteCount;
    property KeyDataLength: word read FKeyDataLength;
    property RecordDataLength: word read FRecordDataLength;
  end;

//  IMP_IB_Buffer