unit T_AccMgr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ICSCTL32, ComCtrls,TAccMgr2,Forms,Dialogs,fAccMgr1;

const
     // Style and messagehandling constants.
     M_QUERY=0;
     M_INS=1;
     M_DEL=2;
     M_EDIT=3;
     M_CONN=4;
     M_LOGON=5;
     M_RECV=6;
     M_RECV2=7;
     M_REESTAB=8;
     M_MessageStrings: array [M_QUERY..M_REESTAB] of string = (
       'Foresprger MAPPER...',
       'Opretter i MAPPER...',
       'Sletter fra MAPPER...',
       'Retter i MAPPER...',
       'Opretter forbindelse til MAPPER...',
       'Logger p MAPPER...',
       'Modtager...',
       'Modtaget %d af %d...',
       'Reetablerer forbindelse. Vent...' );

     ST_QUERY=M_QUERY;
     ST_INS=M_INS;
     ST_DEL=M_DEL;
     ST_EDIT=M_EDIT;
     ST_SMALL=0;
     ST_LARGE=16;


     // Terminalemulator constants.
     TS_ATTRIB=2;
     TS_CHAR=1;
     TS_COLS=80;
     TS_LINES=24;
     TS_MAXSCREENFIELDS=20;
     TS_MESSAGEMARKER=129; // AsciiCharacter 129 is the messagemarker.

     // Blocking status messages
     IC_STATUS_BLOCKING = 262144;
     IC_BLOCKING_ON = 262144;
     IC_BLOCKING_OFF = 262145;

     // Connect status messages
     IC_CONNECT_EOF = 131072;
     IC_CONNECT_CLOSE = 131073;
     IC_CONNECT_OPEN = 131074;
     IC_CONNECT_NOACTIVITY = 131075;
     IC_CONNECT_ACTIVITY = 131076;
     IC_CONNECT_STATUS = 131077;
     IC_CONNECT_BROKEN = 131088;
     IC_CONNECT_JOINED = 131089;
     IC_CONNECT_SERVER = 131090;

     // Standard function key status messages
     IC_FKEY_BREAK = 458752;
     IC_FKEY_1 = 458753;
     IC_FKEY_2 = 458754;
     IC_FKEY_3 = 458755;
     IC_FKEY_4 = 458756;
     IC_FKEY_5 = 458757;
     IC_FKEY_6 = 458758;
     IC_FKEY_7 = 458759;
     IC_FKEY_8 = 458760;
     IC_FKEY_9 = 458761;
     IC_FKEY_10 = 458762;
     IC_FKEY_11 = 458763;
     IC_FKEY_12 = 458764;
     IC_FKEY_13 = 458765;
     IC_FKEY_14 = 458766;
     IC_FKEY_15 = 458767;
     IC_FKEY_16 = 458768;
     IC_FKEY_17 = 458769;
     IC_FKEY_18 = 458770;
     IC_FKEY_19 = 458771;
     IC_FKEY_20 = 458772;
     IC_FKEY_21 = 458773;
     IC_FKEY_22 = 458774;
     IC_FKEY_23 = 458775;
     IC_FKEY_24 = 458776;

     // Uniscope specific function key status messages
     IC_FKEY_MSGWAIT = 458752;
     IC_FKEY_SYSMODE = 458775;
     IC_FKEY_WSMODE = 458776;

     // Uniscope specific status messages
     IC_STATUS_UTS = 65536;
     IC_UTS_MSGWAIT = 65543;
     IC_UTS_DESELECT_ACTIVITY = 65649;
     IC_UTS_DESELECT_DID = 65650;
     IC_UTS_DVC_READY = 65552;
     IC_UTS_DVC_BUSY = 65553;
     IC_UTS_DVC_ERROR = 65554;
     IC_UTS_DVC_NOTREADY = 65555;
     IC_UTS_ATTENTION = 65568;
     IC_UTS_POC = 65590;

     // Reactivate status messages
     IC_STATUS_REACTIVATE = 196608;
     IC_REACTIVATE_ON = 196608;
     IC_REACTIVATE_OFF = 196609;

     // RptMsg's
     IC_ERROR_TERMINATE_NOMSG = 12582912;

     eodstring='**END MAP2PC**';
type
  TAccMgr = class(TComponent)
  private
    // Internal datastorage.
    Appl:TApplication; // Pointer to the application using this component.
    ICS: TIcsCtrl; // The OCX library.
    Reestablishing:boolean; // True if during reestablish.

    FSessionPath:string;
    FhSession:word;
    Fx,Fy:integer;
    FEnvironment:string;
    FUsername,FPassword:string;
    FDepartment:integer;
    FTranslateFile:TFileName;
    FIsLoggedOn:boolean;
    FIsConnected:boolean;
    FIsError:boolean;
    FIsMessage:boolean;
    FMessage:string;
    FKeepConnection:boolean;

    RecieveDone,TransmitDone:boolean;
    attr:integer;
    RcvXlate,XmitXlate:array [1..255] of char;
    TermScreen: array [1..TS_LINES,1..TS_COLS,1..2] of char;
    ScreenFields: array [1..TS_MAXSCREENFIELDS] of record
                    x,y:integer;
                    len:integer;
                  end;
    nScreenFields:integer;
    CurrentScreenField:integer;

    // Highlevel field and record handling.
    Records:TStringList;
    CurrentRecord:integer;
    FRecordCount:integer;
    FFieldCount:integer;
    Recordstring:string;
    Startrec:boolean;

    // Private procedures.
    function ReadXlateTable:boolean;
    procedure ClearTermScreen;
    Procedure Home;
    function UpdateScreen(instr:string;l:integer):boolean;
    procedure IcsReceiveDone(Sender: TObject; var RcvData: string; var Length: Integer);
    procedure IcsTransmitDone(Sender: TObject);
    function FindBlank(var x:integer;var y:integer;dir:integer):boolean;
    function FindNonBlank(var x:integer;var y:integer;dir:integer):boolean;

    function FindApplication:TApplication;
    function GetMapperRecords(first:boolean):boolean;
    function PickMapperField(s:string;n:integer):string;

    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;

    // Internal functions.
    procedure IntSendCommand(cmd:string;data:string;style:integer;wait:boolean);
    procedure IntSendPosCommand(x,y:integer;cmd:string;data:string;style:integer;wait:boolean);

    // Property procedure declarations.
    function GetOpenSession:boolean;
    procedure SetOpenSession(value:boolean);
    procedure SetDlgOpenSession(value:boolean);
    procedure SetX(value:integer);
    procedure SetY(value:integer);
    function GetX:integer;
    function GetY:integer;
    procedure SetTranslateFile(value:TFileName);
    function GetFieldNames(Index:integer):string;
    function GetFields(Index:integer):string;

    // Progress procedures.
    procedure StartProgress;
    procedure Progress(s:string;pct:integer);
    procedure EndProgress;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property hSession:word read FhSession;
    property DlgOpenSession:boolean write SetDlgOpenSession;
    property OpenSession:boolean read GetOpenSession write SetOpenSession;
    Property X:integer read GetX write SetX;
    property Y:integer read GetY write SetY;
    property Fields[Index:integer]:string read GetFields;
    property RecordCount:integer read FRecordCount;
    property FieldCount:integer read FFieldCount;
    property FieldNames[Index:integer]:string read GetFieldNames;
    property IsConnected:boolean read FIsConnected;
    property IsLoggedOn:boolean read FIsLoggedOn;
    property IsError:boolean read FIsError;
    property IsMessage:boolean read FIsMessage;
    property Message:string read FMessage;

    procedure Logon;

    // Terminal handling methods.
    function SearchText(text:string;usecase:boolean):boolean;
    function FindText(text:string;usecase:boolean):boolean;
    function GetWord:string;
    procedure NextWord;
    procedure PrevWord;
    function GetLine:string;

    procedure SendFkey(key:longint);
    procedure SendCommand(cmd:string;data:string;style:integer;wait:boolean);
    function SendQuery(cmd:string;data:string;style:integer):integer;
    procedure SendFieldCommand(fld:integer;cmd:string;data:string;style:integer;wait:boolean);
    function SendFieldQuery(fld:integer;cmd:string;data:string;style:integer):integer;
    procedure SendPosCommand(x,y:integer;cmd:string;data:string;style:integer;wait:boolean);
    function SendPosQuery(x,y:integer;cmd:string;data:string;style:integer):integer;


    Procedure ShowTerminal(re:TRichEdit);

    // Record/Field handling methods.
    function MapperStatus(var status:string):boolean;
    function First:boolean;
    function Last:boolean;
    function Next:boolean;
    function Prior:boolean;
    function FieldByName(name:string):string;
    function FieldIndexByName(name:string):integer;

  published
    { Published declarations }
    property SessionPath:string read FSessionPath write FSessionPath;
    property Environment:string read FEnvironment write FEnvironment;
    property Username:string read FUsername write FUsername;
    property Password:string read FPassword write FPassword;
    property Department:integer read FDepartment write FDepartment;
    property TranslateFile:TFileName read FTranslateFile write SetTranslateFile;
    property KeepConnection:boolean read FKeepConnection write FKeepConnection;
  end;

var
   TmpS:string;
   DontRecieve:boolean; // For debugpurpose only. =true doesnt update internal screen.

procedure Register;

implementation

// Progress functions.
procedure TAccMgr.StartProgress;
begin
     fProgress:=TfProgress.create(self);
     fProgress.Progress.min:=0;
     fProgress.Progress.max:=100;
     fProgress.Progress.position:=0;
     fProgress.Status.caption:='Vent...';
     FProgress.Status.refresh;
     fProgress.show;
end;
procedure TAccMgr.Progress(s:string;pct:integer);
begin
     if fProgress=nil then StartProgress;
     if s<>'' then fProgress.Status.caption:=s;
     fProgress.Progress.position:=pct;
     fProgress.Progress.refresh;
     fProgress.Status.refresh;
end;
procedure TAccMgr.EndProgress;
begin
     fProgress.hide;
     fProgress.free;
     fProgress:=nil;
end;

{ *******************************************************************
  *            TACCMGR HIGHLEVEL COMMANDS                           *
  ******************************************************************* }
// Return mapper status.
function TAccMgr.MapperStatus(var status:string):boolean;
var
   x:integer;
   s:string;
begin
     // Look at first line. Retrive $....$ sequence.
     s:='';
     for x:=1 to TS_COLS do
     begin
          if TermScreen[1,x,TS_CHAR]='$' then
          begin
               if s<>'' then break;
               s:=s+TermScreen[1,x,TS_CHAR];
          end;
     end;

     if s='$OK$' then result:=true
     else result:=false;
end;

// Internal function for picking data from specific pos in ; formatted string.
function TAccMgr.PickMapperField(s:string;n:integer):string;
var
   r:string;
   i,fc:integer;
begin
//messagedlg('PICKMAPPERFIELD '+s+' n='+inttostr(n),mtinformation,[mbok],0);
     // Now parse headerrecord to find start of field.
     fc:=0;
     i:=1;
     while (fc < n) and (i<length(s)) do
     begin
        if s[i]=';' then inc(fc);
        inc(i);
     end;

     // OK now copy fielddata.
     r:='';
     while i<=length(s) do
     begin
          if s[i]=';' then break;
          r:=r+s[i];
          inc(i);
     end;
     Result:=r;
end;

// Get fielddata from field n.
function TAccMgr.GetFields(Index:integer):string;
begin
     // If no records, cant see fields.
     if (Records.Count<=0) or (Index<0) or (Index>=FFieldCount) then
     begin
          Result:='';
          exit;
     end;

     Result:=PickMapperField(Records.strings[CurrentRecord],Index);
end;

// Get fielddata by name.
function TAccMgr.FieldByName(name:string):string;
var
   i:integer;
begin
     // If no records, cant see fields.
     if (Records.Count<=0) then
     begin
          Result:='';
          exit;
     end;

     // Look for fieldname.
     for i:=0 to FFieldCount-1 do
         if GetFieldNames(i)=name then break;
     if i>=FFieldCount then
     begin
          Result:='';
          exit;
     end;

     Result:=PickMapperField(Records.strings[CurrentRecord],i);
end;

// Get fieldindex by name.
function TAccMgr.FieldIndexByName(name:string):integer;
var
   i:integer;
begin
     // If no records, cant see fields.
     if (Records.Count<=0) then
     begin
          Result:=-1;
          exit;
     end;

     // Look for fieldname.
     for i:=0 to FFieldCount-1 do
         if GetFieldNames(i)=name then break;
     if i>=FFieldCount then
     begin
          Result:=-1;
          exit;
     end;

     Result:=i;
end;

// Select next record.
function TAccMgr.Next:boolean;
begin
     if CurrentRecord >= FRecordCount then
     begin
          Result:=false;
          exit;
     end;
     inc(CurrentRecord);
     Result:=true;
end;

// Select previous record.
function TAccMgr.Prior:boolean;
begin
     if (CurrentRecord <= 1) or (FRecordCount <= 0) then
     begin
          Result:=false;
          exit;
     end;
     dec(CurrentRecord);
     Result:=true;
end;

// Select First record.
function TAccMgr.First:boolean;
begin
     if FRecordCount<=0 then
     begin
          Result:=false;
          exit;
     end;
     CurrentRecord:=1;
     Result:=true;
end;

// Select Last record.
function TAccMgr.Last:boolean;
begin
     if FRecordCount<=0 then
     begin
          Result:=false;
          exit;
     end;
     CurrentRecord:=RecordCount;
     Result:=true;
end;

// Return fieldname for field n.
function TAccMgr.GetFieldNames(Index:integer):string;
var
   s:string;
begin
     // If no records, cant see fields.
     if (Records.Count<=0) or (Index<0) or (Index>=FFieldCount) then
     begin
          Result:='';
          exit;
     end;

     s:=Records.strings[0];
     Result:=PickMapperField(s,Index);
end;

// Internal function for retrieving records from mapper.
// Returns true if more records to fetch on next screen, else false.
function TAccMgr.GetMapperRecords(first:boolean):boolean;
var
   x,y:integer;
   i:integer;
   eodfound:boolean;
   ch,ch1:char;
   s:string;
label
     L_exit;
begin
     // If on next screen, dont reset.
     if first then
     begin
          // If old records stored, clear them.
          Records.clear;
          RecordString:='';
          startrec:=false;
     end;

     // Scan screen.
     for y:=2 to TS_LINES-1 do
     begin
          // Check if EOD string specified on line.
          eodfound:=true;
          for x:=1 to length(eodstring) do
          begin
               ch1:=TermScreen[y,x,TS_CHAR];
               if ch1<>eodstring[x] then
               begin
                    eodfound:=false;
                    break;
               end;
          end;
          if eodfound then
          begin
               RecordString:=trim(RecordString);
               if RecordString<>'' then Records.append(RecordString);
               goto L_exit;
          end;

          // Not found EOD, check line for recordfields.
          for x:=1 to TS_COLS do
          begin

               ch:=TermScreen[y,x,TS_CHAR];

               // Seperate screendata into records starting with chr(35) (#).
               if ch=chr(35) then
               begin
                    // Check if next record, save previous.
                    if startrec then
                    begin
                         RecordString:=trim(RecordString);
{if pos('BINDELED',RecordString)>0 then
begin
Dontrecieve:=true;
     goto L_exit;
end;
}
                         if RecordString<>'' then Records.append(RecordString);
                         RecordString:='';
                    end
                    else
                    begin
                         startrec:=true;
                         RecordString:='';
                    end;
               end
               // Put recordline together.
               else
                    RecordString:=RecordString+ch;
          end;
     end;

     Result:=true;
     exit;

// Got end of records flag.
L_exit:
     // Calculate recordcount.
     FRecordCount:=Records.Count-1; // Deduct headerrecord. Result=-1 if error.

     // Now count number of fields.
     FFieldCount:=0;
     CurrentRecord:=0;
     if FRecordCount>=0 then
     begin
          // Now parse headerrecord.
          s:=Records.strings[0];
          for i:=1 to length(s) do
              if s[i]=';' then inc(FFieldCount);
          inc(FFieldCount);

          // While were are at it, reset currentrecord.
          CurrentRecord:=1;
     end;

     // Give recordcount back.
     Result:=false;
end;

// Send query, wait for answer.
function TAccMgr.SendQuery(cmd:string;data:string;style:integer):integer;
var
   First:boolean;
   total:integer;
   pct:integer;
   s:string;
   ms:string;
begin
     ms:=M_MessageStrings[style and 15];
     Progress(ms,25);
     SendCommand(cmd,data,style,true);
     Progress(ms,75);

     // Look for how many records returned.
     if (not FindText('ANTAL',false)) or (FY>2) then
     begin
          Result:=-1;
          EndProgress;
          exit;
     end;
     NextWord;
     s:=getword;
//messagedlg('s='+s+format(' x=%d, y=%d',[Fx,Fy]),mtinformation,[mbok],0);
     total:=strtoint(s);

     Progress(M_MessageStrings[M_RECV],0);

     // Loop to get all records.
     First:=true;
     while true do
     begin
          // Now wait for result.
          while (not TransmitDone) and (not RecieveDone) do
          begin
               Appl.processmessages;
          end;

          // OK recieved something, get mapper record into recordbuffer.
//messagedlg('Recieving records '+inttostr(integer(first)),mtinformation,[mbok],0);
          if not GetMapperRecords(First) then break;

          // Update progress.
          s:=format(M_MessageStrings[M_RECV2],[Records.Count,total]);
          Progress(s,trunc(100.0*(Records.count/total)));

          // OK, next screen.
          SendPosCommand(22,1,chr(30)+chr(9)+'+ ','',ST_SMALL,true);

          // Check if we got an acceptable response.
          if (not FindText('LINE',false)) or (FY>1) or (FX>1) then
          begin
               FIsError:=true;
               Result:=-1;
               EndProgress;
               exit;
          end;

          First:=false;
     end;
     EndProgress;
     Result:=FRecordCount;
end;



{ *******************************************************************
  *            CONSTRUCTORS AND PROPERTY METHODS                    *
  ******************************************************************* }

// Constructor.
constructor TAccMgr.Create(AOwner:TComponent);
begin
     inherited create(AOwner);
     Records:=TStringList.create;
     Appl:=FindApplication;
     ICS:=nil;
     Reestablishing:=false;
     nScreenFields:=0;
     CurrentScreenField:=-1; // -1 is HOME.
     FIsLoggedOn:=false;
     FIsConnected:=false;

//     if Appl<>nil then
//        Appl.Messagebox('TEST1','TEST2',mb_ok);
//     messagedlg('In create',mtinformation,[mbok],0);
end;

// Destructor.
destructor TAccMgr.Destroy;
begin
     Records.free;
     inherited Destroy;
end;

// Find application object.
function TAccMgr.FindApplication:TApplication;
var
   component:TComponent;
begin

   // Check if in designmode, no application object existing.
   component:=self;
   if component.componentstate = [csDesigning] then
   begin
        Result:=nil;
        exit;
   end;

   // Look for top component in list.
   while component.owner <> nil do
         component:=component.owner;
   result:=TApplication(component);
end;

// Set translation table.
procedure TAccMgr.SetTranslateFile(value:TFileName);
var
   i:integer;
begin
     FTranslateFile:=value;
     if self.componentstate = [csDesigning] then exit;
     ReadXlateTable;
end;

// Logon.
procedure TAccMgr.Logon;
var
   tries:integer;
begin
     if FIsLoggedOn then exit;

     Progress(M_MessageStrings[M_LOGON],25);
     for tries:=0 to 5 do
     begin
          // Make sure we have recieved all from mapper.
          while not RecieveDone do
                appl.processmessages;

          // Now check if on loginscreen.
          if FindText('User-id',false) then
          begin
               // Send login sequence.
               IntSendPosCommand(1,1,']',ansiuppercase(FUserName)+','+inttostr(FDepartment)+','+ansiuppercase(FPassword),ST_SMALL,true);
               Progress('',50);

               // Check if 'invalid' keyword in top line, we've got contact with mapper but didnt login.
               if (not FindText('Invalid',false)) or (Fy > 1) then
               begin
                  // Look if we are logged in.
                  if FindText('Cabinet',false) then
                  begin
                       FIsLoggedOn:=true;
                       Progress('',100);
                       EndProgress;
                       exit;
                  end;
               end;
          end;

          // Check if session established.
          if not FIsConnected then
          begin
               // Try to make connection and check screen again.
               SetOpenSession(true);
               continue;
          end;

          // Check if to specify environment.
          if (FEnvironment<>'') and FindText('SESSION PATH OPEN TO',false) then
          begin
               IntSendPosCommand(1,1,FEnvironment,'',ST_SMALL,true);
               continue;
          end;

          // Try a few different responses to get Mapper to respond.
          case tries of
               1: IntSendPosCommand(1,1,'X','',ST_SMALL,true);
               2: IntSendPosCommand(1,1,'','',ST_SMALL,true);
               else IntSendPosCommand(1,1,'^','',ST_SMALL,true);
          end;
     end;
     FIsLoggedOn:=false;
     EndProgress;
end;

// Send Functionkey.
procedure TAccMgr.SendFkey(key:longint);
begin
     if ICS=nil then exit;
     ICS.StatusMessage:=key;
end;

// Internal send command.
procedure TAccMgr.IntSendCommand(cmd:string;data:string;style:integer;wait:boolean);
var
   s:variant;
   l:variant;
   i:integer;
   tdata:string;
   sr:string;
begin
     if ICS=nil then exit;

     // Translate data string.
     tdata:=data;
     if TranslateFile<>'' then
        for i:=1 to length(data) do
            tdata[i]:=XmitXlate[ord(data[i])];

     // Check the style. Large or small command.
     if (style and ST_LARGE)=ST_LARGE then
     begin
          RecieveDone:=false;
          TransmitDone:=false;

          // Convert to variants that the OCX likes to get and do transmit.
          s:=cmd;
          l:=length(s);
          ICS.transmit(s,l);

          // Wait for OK.
          while not RecieveDone do
                appl.processmessages;
          if not MapperStatus(sr) then
          begin
               FIsError:=true;
               FIsMessage:=true;
               FMessage:=sr;
               exit;
          end;

          RecieveDone:=false;
          TransmitDone:=false;

          // Send second part.
          s:=tdata;
          l:=length(s);
          ICS.transmit(s,l);
     end
     else
     begin
          // Convert to variants that the OCX likes to get and do transmit.
          s:=cmd+tdata;
          l:=length(s);
          ICS.transmit(s,l);
     end;

     // If to wait for answer do it.
     if wait or Reestablishing then
     begin
          if Reestablishing then Progress(M_MessageStrings[M_REESTAB],33);
          while not RecieveDone do
                appl.processmessages;
          if Reestablishing then EndProgress;
     end;
end;

// Send command.
procedure TAccMgr.SendCommand(cmd:string;data:string;style:integer;wait:boolean);
var
   i:integer;
begin
     // Check if to try to reestablish connection if lost.
     if FKeepConnection then
     begin
          // Loop in case of lost connection.
          for i:=1 to 3 do
          begin

               // Check if no OCX loaded thus no session. Establish it.
               if ICS=nil then
               begin
                    SetOpenSession(true);
                    Reestablishing:=true;
               end;

               // If OCX loaded but not session established. Establish it.
               if (not ICS.isestablished) or FindText('SESSION PATH CLOSED',true) or
                  FindText('ENTER SESSION ESTABLISHMENT REQUEST',true) then
               begin
                    SetOpenSession(true);
                    Reestablishing:=true;
               end;

               // If session established but not logged on. Log on.
               if (not FIsLoggedOn) or FindText('press SignOn to',false) then
               begin
                    Logon;
                    Reestablishing:=true;
               end;

               // Send the command.
               IntSendCommand(cmd,data,style,wait);

               // Check if MAPPER says no session established. Establish it.
               if (not ICS.isestablished) or FindText('SESSION PATH CLOSED',true) or
                  FindText('ENTER SESSION ESTABLISHMENT REQUEST',true) then
               begin
                    Reestablishing:=true;
                    continue;
               end;
               break;
          end;
     end
     else
     begin
          if ICS<>nil then IntSendCommand(cmd,data,style,wait);
     end;
     Reestablishing:=false;
end;

// Send command in specific field.
procedure TAccMgr.SendFieldCommand(fld:integer;cmd:string;data:string;style:integer;wait:boolean);
var
   s:string;
begin
     if (fld<0) or (fld>=nScreenFields) then exit;
     s:=chr(27)+chr(11)+chr(31+ScreenFields[fld].y)+chr(31+ScreenFields[fld].x)+chr(0)+chr(15);
     SendCommand(s+cmd,data,style,wait);
end;

// Send command at specific position.
procedure TAccMgr.IntSendPosCommand(x,y:integer;cmd:string;data:string;style:integer;wait:boolean);
var
   s:string;
begin
     if (x<=0) or (y<=0) or (x>TS_COLS) or (y>TS_LINES) then exit;
     s:=chr(27)+chr(11)+chr(31+y)+chr(31+x)+chr(0)+chr(15);
     IntSendCommand(s+cmd,data,style,wait);
end;

// Send command at specific position.
procedure TAccMgr.SendPosCommand(x,y:integer;cmd:string;data:string;style:integer;wait:boolean);
var
   s:string;
begin
     if (x<=0) or (y<=0) or (x>TS_COLS) or (y>TS_LINES) then exit;
     s:=chr(27)+chr(11)+chr(31+y)+chr(31+x)+chr(0)+chr(15);
     SendCommand(s+cmd,data,style,wait);
end;

// Send query in specific field, wait for answer.
function TAccMgr.SendFieldQuery(fld:integer;cmd:string;data:string;style:integer):integer;
var
   s:string;
begin
     if (fld<0) or (fld>=nScreenFields) then exit;
     s:=chr(27)+chr(11)+chr(31+ScreenFields[fld].y)+chr(31+ScreenFields[fld].x)+chr(0)+chr(15);
     Result:=SendQuery(s+cmd,data,style);
end;

// Send query at specific pos, wait for answer.
function TAccMgr.SendPosQuery(x,y:integer;cmd:string;data:string;style:integer):integer;
var
   s:string;
begin
     if (x<=0) or (y<=0) or (x>TS_COLS) or (y>TS_LINES) then exit;
     s:=chr(27)+chr(11)+chr(31+y)+chr(31+x)+chr(0)+chr(15);
     Result:=SendQuery(s+cmd,data,style);
end;

// Return line.
function TAccMgr.GetLine:string;
var
   s:string;
   x:integer;
begin
     s:='';
     for x:=1 to TS_COLS do
         s:=s+TermScreen[Fy,x,TS_CHAR];
     Result:=s;
end;

// Search nonblank. dir<0 then backwards else forwards.
function TAccMgr.FindNonBlank(var x:integer; var y:integer;dir:integer):boolean;
begin
     if dir<0 then
     begin
          // Drop blanks.
          while true do
          begin
               if TermScreen[y,x,TS_CHAR]<>' ' then break;
               dec(x);
               if x<1 then
               begin
                    x:=TS_COLS;
                    dec(y);
                    if y<1 then
                    begin
                         Result:=false;
                         exit;
                    end;
               end;
          end;
     end
     else
     begin
          // Drop blanks.
          while true do
          begin
               if TermScreen[y,x,TS_CHAR]<>' ' then break;
               inc(x);
               if x>=TS_COLS then
               begin
                    x:=1;
                    inc(y);
                    if y>=TS_LINES then
                    begin
                         Result:=false;
                         exit;
                    end;
               end;
          end;
     end;
     Result:=true;
end;

// Search blank. dir<0 then backwards else forwards.
function TAccMgr.FindBlank(var x:integer; var y:integer;dir:integer):boolean;
begin
     if dir<0 then
     begin
          // Drop characters.
          while true do
          begin
               if TermScreen[y,x,TS_CHAR]=' ' then break;
               dec(x);
               if x<1 then
               begin
                    x:=TS_COLS;
                    dec(y);
                    if y<1 then
                    begin
                         Result:=false;
                         exit;
                    end;
               end;
          end;
     end
     else
     begin
          // Drop blanks.
          while true do
          begin
               if TermScreen[y,x,TS_CHAR]=' ' then break;
               inc(x);
               if x>=TS_COLS then
               begin
                    x:=1;
                    inc(y);
                    if y>=TS_LINES then
                    begin
                         Result:=false;
                         exit;
                    end;
               end;
          end;
     end;
     Result:=true;
end;

// Find previous word and position there.
procedure TAccMgr.PrevWord;
var
   x,y:integer;
begin
     x:=Fx;
     y:=Fy;

     // Check if ontop of word, then skip it.
     if TermScreen[y,x,TS_CHAR]<>' ' then
        if not findblank(x,y,-1) then exit;

     // Drop blanks.
     if not findnonblank(x,y,-1) then exit;

     // Find start of word.
     if not findblank(x,y,-1) then exit;

     // Now positioned at space, search forward to get wordstart.
     if not findnonblank(x,y,1) then exit;

     Fx:=x;
     Fy:=y;
end;

// Find next word and position there.
procedure TAccMgr.NextWord;
var
   x,y:integer;
begin
     x:=Fx;
     y:=Fy;

     // Check if ontop of word, then skip it.
     if TermScreen[y,x,TS_CHAR]<>' ' then
        if not findblank(x,y,1) then exit;

     // Drop blanks.
     if not findnonblank(x,y,1) then exit;

     Fx:=x;
     Fy:=y;
end;

// Return word at current x,y pos. and pos at following blank.
function TAccMgr.GetWord:string;
var
   x,y:integer;
   s:string;
label
     L_result;
begin
     Result:='';
     y:=Fy;
     x:=Fx;

     // Look for nonblank character.
     if not FindNonBlank(x,y,1) then exit;

     // Loop used for shifting line.
     s:='';
     while true do
     begin
          while x<=TS_COLS do
          begin
               if TermScreen[y,x,TS_CHAR]=' ' then goto L_result;
               s:=s+TermScreen[y,x,TS_CHAR];
               inc(x);
          end;
          x:=1;
          inc(y);
          if y>TS_LINES then
          begin
               y:=TS_LINES;
               x:=TS_COLS;
               goto L_result;
          end;
     end;

L_result:
     Fx:=x;
     Fy:=y;
     Result:=s;
end;

// Search for text on terminalscreen starting from HOME.
function TAccMgr.FindText(text:string;usecase:boolean):boolean;
begin
     Home;
     Result:=SearchText(text,usecase);
end;

// Search for text on terminalscreen starting from FX,FY.
function TAccMgr.SearchText(text:string;usecase:boolean):boolean;
var
   x1:integer;
   x,y:integer;
   i,j:integer;
   found:boolean;
begin
     x1:=Fx;
     for y:=Fy to TS_LINES do
     begin
          for x:=x1 to TS_COLS do
          begin
               found:=true;
               // Compare with case.
               if usecase then
               begin
                    for i:=1 to length(text) do
                    begin
                         try
                            if TermScreen[y,x+i-1,TS_CHAR]<>text[i] then
                            begin
                                 found:=false;
                                 break;
                            end;
                         except
                               found:=false;
                               break;
                         end;
                    end;
               end
               else
               begin
                    for i:=1 to length(text) do
                    begin
                         try
                            if ansilowercase(TermScreen[y,x+i-1,TS_CHAR])<>ansilowercase(text[i]) then
                            begin
                                 found:=false;
                                 break;
                            end;
                         except
                               found:=false;
                               break;
                         end;
                    end;
               end;
               if found then
               begin
                    Fx:=x;
                    Fy:=y;
                    Result:=true;
                    exit;
               end;
          end;
          x1:=1;
     end;
     Result:=false;
end;

// Set X-coord.
procedure TAccMgr.SetX(value:integer);
begin
     if (value<1) or (value > TS_COLS) then exit;
     Fx:=value;
end;

// Set Y-coord.
procedure TAccMgr.SetY(value:integer);
begin
     if (value<1) or (value > TS_COLS) then exit;
     Fy:=value;
end;

// Get X-coord.
function TAccMgr.GetX:integer;
begin
     result:=Fx;
end;

// Get Y-coord.
function TAccMgr.GetY:integer;
begin
     result:=Fy;
end;

// Open session.
procedure TAccMgr.SetOpenSession(value:boolean);
var
   i:integer;
begin
     // Clear terminalscreen.
     ClearTermScreen;
     Home;

     // If to open session.
     if value then
     begin
          Progress(M_MessageStrings[M_CONN],25);
          ReadXlateTable;

          RecieveDone:=false;
          TransmitDone:=true;
          if ICS<>nil then
          begin
               ICS.free;
               ICS:=nil;
          end;
          ICS:=TIcsCtrl.create(self);
          if ICS=nil then exit;
          Progress('',50);
          ICS.PathName:=FSessionPath;
          ICS.OnReceiveDone:=IcsReceiveDone;
          ICS.open:=true;
          Progress('',66);
          i:=0;

          // An ugly waitloop.
          while (not ICS.isestablished) and (i<1000) do
          begin
               appl.processmessages;
               inc(i);
          end;
          FhSession:=ICS.hSession;
          FIsConnected:=ICS.isestablished;
          FIsLoggedOn:=false;
          Progress('',100);
          EndProgress;
     end

     // Else to close it.
     else
     begin
          if ICS=nil then exit;
          if ICS.isestablished then ICS.free;
          ICS.Free;
          ICS:=nil;
          FhSession:=0;
          RecieveDone:=true;
          TransmitDone:=true;
          FIsConnected:=false;
          FIsLoggedOn:=false;
     end;
end;

// Get status of session.
function TAccMgr.GetOpenSession:boolean;
begin
     Result:=(hSession<>0);
end;

// Show OpenSession dialog.
procedure TAccMgr.SetDlgOpenSession(value:boolean);
var
   frm: TDlgOpenSession;
   i:integer;
begin
     if value then
     begin
          // Prepare ICS.
          ICS:=TIcsCtrl.create(self);
          if ICS=nil then exit;

          // Prepare opendialog.
          frm:=TDlgOpenSession.create(self);

          // Build list of paths.
          ICS.hWndVBList:=frm.SessionList.handle;
          ICS.Action:=1;
          ICS.free;
          ICS:=nil;

          // Show the opendialog.
          if frm.showmodal = mrOK then
          begin
               FSessionPath:=TmpS;
               SetOpenSession(true);
          end;
          frm.close;
     end
     // Else to close it.
     else
     begin
          if ICS=nil then exit;
          if ICS.isestablished then ICS.free;
          ICS.Free;
          ICS:=nil;
          FhSession:=0;
     end;
end;

// The reception eventhandler for ICS.
procedure TAccMgr.IcsReceiveDone(Sender: TObject; var RcvData: string;
  var Length: Integer);
var
   x:integer;
   ch:char;
begin
     if ICS=nil then exit;
     FIsError:=false;
     FIsMessage:=false;
     if DontRecieve or UpdateScreen(RcvData,Length) then RecieveDone:=true;

     // If recieved messagemarker, get messagetext.
     FMessage:='';
     if FIsMessage then
     begin
          // Look for 1. messagemarker.
          for x:=1 to TS_COLS do
              if TermScreen[1,x,TS_CHAR]=chr(TS_MESSAGEMARKER) then break;
          inc(x);
          // Now copy until 2. messagemarker or EOL.
          while x<=TS_COLS do
          begin
              ch:=TermScreen[1,x,TS_CHAR];
              if ch=chr(TS_MESSAGEMARKER) then break;
              FMessage:=FMessage+ch;
              inc(x);
          end;
          FMessage:=trim(FMessage);
     end;
end;

// The transmit eventhandler for ICS.
procedure TAccMgr.IcsTransmitDone(Sender: TObject);
begin
     if ICS=nil then exit;
     TransmitDone:=true;
     RecieveDone:=false;
end;

{ *******************************************************************
  *                   TERMINAL EMULATOR PROCEDURES                  *
  ******************************************************************* }
// Read translationfile.
function TAccMgr.ReadXlateTable:boolean;
var
   f:textfile;
   s:string;
   i,j,k:integer;
   doread:boolean;
begin
     // Reset tables.
     for i:=1 to 255 do
     begin
          RcvXlate[i]:=chr(i);
          XmitXlate[i]:=chr(i);
     end;
     if FTranslateFile='' then
     begin
          Result:=true;
          exit;
     end;

     // OK, file given, try to open.
     try
        AssignFile(f,FTranslateFile);
        FileMode:=0;
        Reset(f);

        // Only readin data between BEGIN and END block.
        doread:=false;
        while not eof(f) do
        begin
             ReadLn(f,s);

             // If to readin the data (between BEGIN and END).
             if doread then
             begin
                  // Syntax: Showchar = Mapperchar.
                  i:=pos('=',s);
                  if i>0 then
                  begin
                       j:=strtoint(trim(copy(s,i+1,10)));
                       k:=strtoint(trim(copy(s,1,i-1)));
//messagedlg(format('k=%d = j=%d',[k,j]),mtinformation,[mbok],0);
                       if (j>0) and (k>0) then
                       begin
                            RcvXlate[j]:=chr(k);
                            XmitXlate[k]:=chr(j);
                       end;
                  end;
             end
             else
             begin
                  // Check for BEGIN.
                  if (pos('BEGIN',s)>0) or (pos('begin',s)>0) then
                  begin
                       doread:=true;
                       continue;
                  end;

                  // Check for END.
                  if (pos('END',s)>0) or (pos('end',s)>0) then break;
             end;
        end;
        closefile(f);
        Result:=true;
     except
        messagedlg('T_AccMgr: Kan ikke indlse konverteringsfil: '+FTranslateFile,mterror,[mbok],0);
        Result:=false;
     end;
end;

// Clear virtual terminal screen.
procedure TAccMgr.ClearTermScreen;
var
   i,j:integer;
begin
     for i:=1 to TS_LINES do
         for j:=1 to TS_COLS do
         begin
              TermScreen[i,j,TS_CHAR]:=' ';
              TermScreen[i,j,TS_ATTRIB]:=#0;
         end;

     // Clear screenfields.
     nScreenFields:=0;
     CurrentScreenField:=-1;
end;

// Home cursor on virtual terminal screen.
procedure TAccMgr.Home;
begin
     Fx:=1;
     Fy:=1;
end;

// Update terminalscreen.
function TAccMgr.UpdateScreen(instr:string;l:integer):boolean;
var
   i:integer;
   ch1,ch2:char;
   GetNextScreen:boolean;
begin
     GetNextScreen:=false;
     { Go through line and decipher it. }
     i:=1;
     while i<l do
     begin
          ch1:=RcvXlate[ord(instr[i])];

          // Error marker.
          if ch1=#28 then
          begin
               ch1:=chr(TS_MESSAGEMARKER);
               FIsMessage:=true;
          end;

          case ch1 of

               // Commandfield.
               #30: begin
                      inc(i);
                      if nScreenFields<TS_MAXSCREENFIELDS then
                      begin
                           ScreenFields[nScreenFields].x:=Fx;
                           ScreenFields[nScreenFields].y:=Fy;
                           inc(nScreenFields);
                      end;
                      TermScreen[Fy,Fx,TS_CHAR]:='';
                      inc(Fx);
                      if Fx>TS_COLS then
                      begin
                           Fx:=1;
                           inc(Fy);
                           if Fy>TS_LINES then Fy:=TS_LINES;
                      end;
                      TermScreen[Fy,Fx,TS_CHAR]:=' ';
                      if Fx>TS_COLS then
                      begin
                           Fx:=1;
                           inc(Fy);
                           if Fy>TS_LINES then Fy:=TS_LINES;
                      end;
                   end;

               // Jump to next known field.
               #9: begin
                     inc(i);
                     if nScreenFields>0 then
                     begin
                          inc(CurrentScreenField);
                          if CurrentScreenField>=nScreenFields then
                          begin
                               CurrentScreenField:=-1;
                               Home;
                          end;
                          Fx:=ScreenFields[CurrentScreenField].x;
                          Fy:=ScreenFields[CurrentScreenField].y;
                     end
                     else
                         Home;
                   end;

               // Some form of protected field.
               #25: begin
                      inc(i);
                      if instr[i] = ' ' then
                      begin
                         inc(i);
                         inc(i);
                      end;
                      inc(i);
                      inc(i);
                    end;

               // Escape character.
               #27: begin
                         inc(i);
                         if i>l then break;
                         ch2:=instr[i];
                         inc(i);
                         case ch2 of
                              'e': home;
                              'h': home;

                              #11: begin
                                     Fy:=ord(instr[i])-31;
                                     Fx:=ord(instr[i+1])-31;
                                     attr:=ord(instr[i+2]);
                                     inc(i,3);
                                   end;
                              'M': begin
                                      ClearTermScreen;
                                   end;
                              'T': begin     // Indication next screen ready.
                                      GetNextScreen:=true;
                                   end;

                         end;
                   end;

               // Linefeed.
               #10: begin
                         inc(Fy);
                         if Fy>TS_LINES then Fy:=TS_LINES;
                         inc(i);
                    end;

               // Char.Return.
               #13: begin
                      Fx:=1;
                      inc(Fy);
                      if Fy>TS_LINES then Fy:=TS_LINES;
                      inc(i);
                    end;

               else begin
                         if ch1>=#32 then
                         begin
                              TermScreen[Fy,Fx,TS_CHAR]:=ch1;
                              inc(Fx);
                              if Fx>TS_COLS then
                              begin
                                   Fx:=1;
                                   inc(Fy);
                                   if Fy>TS_LINES then Fy:=TS_LINES;
                              end;
                         end;
                         inc(i);
                    end;
          end;
     end;

     // Check if to recieve next screen means not finished recieving.
     if GetNextScreen then
     begin
          IntSendPosCommand(1,1,'','',ST_SMALL,true);
          Result:=false;
     end
     else
         Result:=true;
end;

// Show terminalscreen.
procedure TAccMgr.ShowTerminal(re:TRichEdit);
var
   i,j:integer;
   c:char;
   s:string;
begin
//     RichEdit1.Font.Name:='Courier';
     re.lines.clear;
     for i:=1 to TS_COLS do s:=s+' ';

     for i:=1 to TS_LINES do
     begin
         for j:=1 to TS_COLS do
         begin
              c:=TermScreen[i,j,TS_CHAR];
              if c<>#0 then s[j]:=c
              else s[j]:=' ';
         end;
         re.lines.append(s);
     end;
end;

{ ********************************************************************
  *                 DELPHI REGISTRATION PROCEDURE                    *
  ******************************************************************** }
procedure Register;
begin
  RegisterComponents('MAPPER_by_Kim_Madsen', [TAccMgr]);
end;

initialization
  DontRecieve:=false;

end.
