unit custdate;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, Mask, DBCtrls, Buttons, cal;

type

  TDateButton = class(TBitBtn)
  private
  protected
     procedure Click; override;
  public
  published
  end;


  TDBDateEdit = class(TCustomControl)
  private
  FButton: TDateButton;
  FEdit: TDBEDit;
  FDataSource: TDataSource;
  FDataField: string;
  FYearinterval: integer;
  function GetText: string;
  procedure SetText(Value: string);
  procedure SetDataSource(Value: TDataSource);
  procedure SetDataField(const Value: string);
  procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    { Private declarations }
  protected
  procedure WMSize( var Message: TWMSize ); message WM_SIZE;
  procedure Paint;override;

    { Protected declarations }
  public
  constructor Create(AOwner: TComponent);override;
  destructor Destroy; override;
  property Text: string read GetText write SetText;
  property Hint;
  procedure SetFocus; override;
    { Public declarations }
  published
  property DataField: string read FDataField write SetDataField;
  property DataSource: TDataSource read FDataSource write SetDataSource;
  property YearInterval: integer read Fyearinterval write Fyearinterval;
  property Color default clWhite;
  property Font;
  property TabOrder;
  property TabStop;
  property Visible;
  property Enabled;
  property OnClick;
  property OnDblClick;
  property OnDragDrop;
  property OnDragOver;
  property OnEndDrag;
  property OnEnter;
  property OnExit;
  property OnKeyDown;
  property OnKeyPress;
  property OnKeyUp;
  property OnMouseDown;
  property OnMouseUp;
  property OnMouseMove;
    { Published declarations }
  end;

procedure Register;

var
  frmCalendar: TCalForm;

implementation

{$R CUSTDATE}
procedure Register;
begin
  RegisterComponents('Data Controls', [TDBDateEdit]);
end;

constructor TDBDateEdit.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
Width := 123;
Height := 24;
Color := clWhite;
YearInterval:= 15;
FButton := TDateButton.Create(Self);
FButton.Parent := Self;
FButton.Glyph.Handle := LoadBitmap( hInstance, 'DATEBUTTON' );
FButton.Tabstop := False;
FEdit := TDBEdit.Create(Self);
FEdit.AutoSize := False;
FEdit.Parent := Self;
Fedit.ParentCtl3d := False;
Fedit.Ctl3D := True;
FEdit.ParentColor := True;
FEdit.OnKeyDown := EditKeyDown;
end;


destructor TDBDateEdit.Destroy;
begin
FButton := nil;
Fedit := nil;
inherited Destroy;
end;

procedure TDBDateEdit.Paint;
begin
with Canvas do
begin
moveto(0,0);
pen.color := clGray;
lineto(width-1,0);
pen.color := clWhite;
lineto(width-1,height-1);
lineto(0, height-1);
end;
end;

procedure TDBDateEdit.WMSize( var Message: TWMSize );
begin
FButton.Height := Height-2;
FButton.Width := 20;
FButton.left := Width - 21;
FButton.top := 1;
Fedit.height := height-2;
Fedit.left := 1;
Fedit.width := Width - 20;
Fedit.top := 1;
end;

procedure TDateButton.Click;
var
  editParent: TDBDateEdit;
  place: TPoint;

begin
  editParent := TDBDateEdit( Parent );
  editParent.datasource.edit;
  place.X:=editparent.left;
  place.Y:=editparent.top + editparent.height;
  frmCalendar := TCalForm.Create( editParent );
  frmCalendar.left:=(editparent.parent).ClienttoScreen(place).X;
  frmCalendar.top:=(editparent.parent).ClienttoScreen(place).Y;

  {frmCalendar.left:=(editparent.Owner as TForm).ClienttoScreen(place).X;
  frmCalendar.top:=(editparent.Owner as TForm).ClienttoScreen(place).Y;}
  frmCalendar.ShowModal;
  frmCalendar.Free;
  SendMessage(TForm(editParent.Owner).Handle, WM_NEXTDLGCTL, 0, 0);
  inherited Click;
end;

function TDBDateEdit.GetText: string;
begin
Result := datetostr(FEdit.datasource.dataset.fieldbyname(datafield).AsDateTime);
end;

procedure TDBDateEdit.SetText(Value: string);
begin
FEdit.datasource.dataset.fieldbyname(datafield).AsDateTime := strtodate(Value);
end;

procedure TDBDateEdit.SetDataSource(Value: TDataSource);
begin
FEdit.DataSource := Value;
FDataSource := Value;
end;

procedure TDBDateEdit.SetDataField(const Value: string);
begin
FEdit.DataField := Value;
FDataField := Value;
end;

procedure TDBDateEdit.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Key = VK_UP) or (Key = VK_DOWN) then
begin
FButton.Click;
Key := 0;
end;
end;

procedure TDBDateEdit.SetFocus;
begin
FEdit.SetFocus;
end;
end.
