Unit InfVer;
{-------------------------------------------------}
{                                                 }
{ This code was written by : Aristide Torrelli    }
{                                                 }
{ This code is copyright 1997 by                  }
{       AT Soft                                   }
{                                                 }
{-------------------------------------------------}

{---------------------------------------------------------}
{                                                         }
{ Legge varie informazioni dalla risorsa VersionInfo, se  }
{ presente nel .exe                                       }
{                                                         }
{ It reads various information from the VersionInfo       }
{  Resource if present in the .exe                        }
{                                                         }
{                                                         }
{---------------------------------------------------------}

interface

uses
  forms, windows, sysutils, classes, dsgnintf;

type
  TInfoVersion = class(TComponent)
  private
    { Private Declarations }
    FCompanyName: string;
    FFileDescription: string;
    FFileVersion: string;
    FInternalName: string;
    FLegalCopyright: string;
    FOriginalFilename: string;
    FProductName: string;
    FProductVersion: string;
    FTranslation:string;
  protected
    { Protected Declarations }
  public
    { Public Declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Execute;
    property CompanyName: string read FCompanyName;
    property FileDescription: string read FFileDescription;
    property FileVersion: string read FFileVersion;
    property InternalName: string read FInternalName;
    property LegalCopyright: string read FLegalCopyright;
    property OriginalFilename: string read FOriginalFilename;
    property ProductName: string read FProductName;
    property ProductVersion: string read FProductVersion;
  published
  end;

procedure Register;

implementation

{--------------------------------------}
{ InfoVersion.Create                   }
{--------------------------------------}
constructor TInfoVersion.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

{--------------------------------------}
{ InfoVersion.Destroy                  }
{--------------------------------------}
destructor TInfoVersion.Destroy;
begin
  inherited Destroy;
end;

{--------------------------------------}
{ InfoVersion.Execute                  }
{--------------------------------------}
procedure TInfoVersion.Execute;
var VersionBuffer:string;
    VersionSize:integer;
    Dummy:integer;
    punta:pointer;
    Language:string;
    Charset:string;
    Lang:^DWORD;
begin
     VersionSize:=GetFileVersionInfoSize(PChar(Application.EXEName), Dummy);
     if VersionSize<>0 then
        begin
             SetLength(VersionBuffer, VersionSize);
             if GetFileVersionInfo(PChar(Application.EXEName), Dummy, VersionSize, PChar(VersionBuffer)) then
                begin
                     if VerQueryValue(PChar(VersionBuffer),'\VarFileInfo\Translation', Punta, VersionSize ) then
                        begin
                             Lang:=punta;
                             Language:=IntToHex(Lang^, 8);
                             // i primi 4 caratteri sono charset
                             CharSet:=Copy(Language, 1, 4);
                             // i secondi 4 caratteri sono language
                             Language:=Copy(Language, 5, 4);
                             // la stringa da utilizzare  language+charset
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\CompanyName'), pointer(FCompanyName), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\FileDescription'), pointer(FFileDescription), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\FileVersion'), pointer(FFileVersion), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\InternalName'), pointer(FInternalName), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\LegalCopyright'), pointer(FLegalCopyright), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\OriginalFilename'), pointer(FOriginalFilename), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\ProductName'), pointer(FProductName), VersionSize );
                             VerQueryValue(PChar(VersionBuffer),PChar('\StringFileInfo\'+Language+Charset+'\ProductVersion'), pointer(FProductVersion), VersionSize );
                        end;

                end;
        end;
(*
\VarFileInfo\Translation  mi da due numeri decimali
che tradotti in esadecimale mi danno una parte del path
\StringFileInfo\040904E4  inglese
\StringFileInfo\041004E4  italiano
    FCompanyName
    FFileDescription
    FFileVersion
    FInternalName
    FLegalCopyright
    FOriginalFilename
    FProductName
    FProductVersion
*)
end;

{--------------------------------------}
{ Register                             }
{--------------------------------------}
procedure Register;
begin
  RegisterComponents('Freeware', [TInfoVersion]);
end;

end.
