{++

  m a p i t a g s . p a s

  Abstract:

    Automatic conversion of mapitags.h.

  Comments:

    This source file automatically converted by
    htrans 0.91 beta 1 Copyright (c) 1997 Alexander Staubo

  Revision history:

    18-06-1997 20:53 alex  [Autogenerated]
    18-06-1997 20:53 alex  Retouched for release

--}

unit MapiTags;

interface

uses
  Windows, SysUtils, ActiveX, Mapidefs;

(*
 *  M A P I T A G S . H
 *
 *  Property tag definitions for standard properties of MAPI
 *  objects.
 *
 *  The following ranges should be used for all property IDs. Note that
 *  property IDs for objects other than messages and recipients should
 *  all fall in the range 0x3000 to 0x3FFF:
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  0001    0BFF    MAPI_defined envelope property
 *  0C00    0DFF    MAPI_defined per-recipient property
 *  0E00    0FFF    MAPI_defined non-transmittable property
 *  1000    2FFF    MAPI_defined message content property
 *
 *  3000    3FFF    MAPI_defined property (usually not message or recipient)
 *
 *  4000    57FF    Transport-defined envelope property
 *  5800    5FFF    Transport-defined per-recipient property
 *  6000    65FF    User-defined non-transmittable property
 *  6600    67FF    Provider-defined internal non-transmittable property
 *  6800    7BFF    Message class-defined content property
 *  7C00    7FFF    Message class-defined non-transmittable
 *                  property
 *
 *  8000    FFFE    User-defined Name-to-id mapped property
 *
 *  The 3000-3FFF range is further subdivided as follows:
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  3000    33FF    Common property such as display name, entry ID
 *  3400    35FF    Message store object
 *  3600    36FF    Folder or AB container
 *  3700    38FF    Attachment
 *  3900    39FF    Address book object
 *  3A00    3BFF    Mail user
 *  3C00    3CFF    Distribution list
 *  3D00    3DFF    Profile section
 *  3E00    3FFF    Status object
 *
 *  Copyright 1986-1996 Microsoft Corporation. All Rights Reserved.
 *)




{ Determine if a property is transmittable. }



(*
 *  Message envelope properties
 *)

const PR_ACKNOWLEDGEMENT_MODE                      =
   (PT_LONG) or (($0001) shl 16);
const PR_ALTERNATE_RECIPIENT_ALLOWED               = 
   (PT_BOOLEAN) or (($0002) shl 16);
const PR_AUTHORIZING_USERS                         =
   (PT_BINARY) or (($0003) shl 16);
const PR_AUTO_FORWARD_COMMENT                      = 
   (PT_TSTRING) or (($0004) shl 16);
const PR_AUTO_FORWARD_COMMENT_W                    = 
   (PT_UNICODE) or (($0004) shl 16);
const PR_AUTO_FORWARD_COMMENT_A                    = 
   (PT_STRING8) or (($0004) shl 16);
const PR_AUTO_FORWARDED                            =
   (PT_BOOLEAN) or (($0005) shl 16);
const PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID      =
   (PT_BINARY) or (($0006) shl 16);
const PR_CONTENT_CORRELATOR                        =
   (PT_BINARY) or (($0007) shl 16);
const PR_CONTENT_IDENTIFIER                        =
   (PT_TSTRING) or (($0008) shl 16);
const PR_CONTENT_IDENTIFIER_W                      =
   (PT_UNICODE) or (($0008) shl 16);
const PR_CONTENT_IDENTIFIER_A                      = 
   (PT_STRING8) or (($0008) shl 16);
const PR_CONTENT_LENGTH                            =
   (PT_LONG) or (($0009) shl 16);
const PR_CONTENT_RETURN_REQUESTED                  = 
   (PT_BOOLEAN) or (($000A) shl 16);



const PR_CONVERSATION_KEY                          = 
   (PT_BINARY) or (($000) shl 16);

const PR_CONVERSION_EITS                           = 
   (PT_BINARY) or (($000C) shl 16);
const PR_CONVERSION_WITH_LOSS_PROHIBITED           = 
   (PT_BOOLEAN) or (($000D) shl 16);
const PR_CONVERTED_EITS                            = 
   (PT_BINARY) or (($000E) shl 16);
const PR_DEFERRED_DELIVERY_TIME                    = 
   (PT_SYSTIME) or (($000F) shl 16);
const PR_DELIVER_TIME                              = 
   (PT_SYSTIME) or (($0010) shl 16);
const PR_DISCARD_REASON                            = 
   (PT_LONG) or (($0011) shl 16);
const PR_DISCLOSURE_OF_RECIPIENTS                  = 
   (PT_BOOLEAN) or (($0012) shl 16);
const PR_DL_EXPANSION_HISTORY                      =
   (PT_BINARY) or (($0013) shl 16);
const PR_DL_EXPANSION_PROHIBITED                   = 
   (PT_BOOLEAN) or (($0014) shl 16);
const PR_EXPIRY_TIME                               =
   (PT_SYSTIME) or (($0015) shl 16);
const PR_IMPLICIT_CONVERSION_PROHIBITED            = 
   (PT_BOOLEAN) or (($0016) shl 16);
const PR_IMPORTANCE                                = 
   (PT_LONG) or (($0017) shl 16);
const PR_IPM_ID                                    = 
   (PT_BINARY) or (($0018) shl 16);
const PR_LATEST_DELIVERY_TIME                      = 
   (PT_SYSTIME) or (($0019) shl 16);
const PR_MESSAGE_CLASS                             = 
   (PT_TSTRING) or (($001A) shl 16);
const PR_MESSAGE_CLASS_W                           = 
   (PT_UNICODE) or (($001A) shl 16);
const PR_MESSAGE_CLASS_A                           = 
   (PT_STRING8) or (($001A) shl 16);
const PR_MESSAGE_DELIVERY_ID                       = 
   (PT_BINARY) or (($001) shl 16);





const PR_MESSAGE_SECURITY_LABEL                    = 
   (PT_BINARY) or (($001E) shl 16);
const PR_OBSOLETED_IPMS                            = 
   (PT_BINARY) or (($001F) shl 16);
const PR_ORIGINALLY_INTENDED_RECIPIENT_NAME        = 
   (PT_BINARY) or (($0020) shl 16);
const PR_ORIGINAL_EITS                             = 
   (PT_BINARY) or (($0021) shl 16);
const PR_ORIGINATOR_CERTIFICATE                    = 
   (PT_BINARY) or (($0022) shl 16);
const PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED      = 
   (PT_BOOLEAN) or (($0023) shl 16);
const PR_ORIGINATOR_RETURN_ADDRESS                 = 
   (PT_BINARY) or (($0024) shl 16);



const PR_PARENT_KEY                                = 
   (PT_BINARY) or (($0025) shl 16);
const PR_PRIORITY                                  = 
   (PT_LONG) or (($0026) shl 16);



const PR_ORIGIN_CHECK                              = 
   (PT_BINARY) or (($0027) shl 16);
const PR_PROOF_OF_SUBMISSION_REQUESTED             = 
   (PT_BOOLEAN) or (($0028) shl 16);
const PR_READ_RECEIPT_REQUESTED                    = 
   (PT_BOOLEAN) or (($0029) shl 16);
const PR_RECEIPT_TIME                              = 
   (PT_SYSTIME) or (($002A) shl 16);
const PR_RECIPIENT_REASSIGNMENT_PROHIBITED         = 
   (PT_BOOLEAN) or (($002) shl 16);
const PR_REDIRECTION_HISTORY                       = 
   (PT_BINARY) or (($002C) shl 16);
const PR_RELATED_IPMS                              = 
   (PT_BINARY) or (($002D) shl 16);
const PR_ORIGINAL_SENSITIVITY                      = 
   (PT_LONG) or (($002E) shl 16);
const PR_LANGUAGES                                 = 
   (PT_TSTRING) or (($002F) shl 16);
const PR_LANGUAGES_W                               = 
   (PT_UNICODE) or (($002F) shl 16);
const PR_LANGUAGES_A                               = 
   (PT_STRING8) or (($002F) shl 16);
const PR_REPLY_TIME                                = 
   (PT_SYSTIME) or (($0030) shl 16);
const PR_REPORT_TAG                                = 
   (PT_BINARY) or (($0031) shl 16);
const PR_REPORT_TIME                               = 
   (PT_SYSTIME) or (($0032) shl 16);
const PR_RETURNED_IPM                              = 
   (PT_BOOLEAN) or (($0033) shl 16);
const PR_SECURITY                                  = 
   (PT_LONG) or (($0034) shl 16);
const PR_INCOMPLETE_COPY                           = 
   (PT_BOOLEAN) or (($0035) shl 16);
const PR_SENSITIVITY                               = 
   (PT_LONG) or (($0036) shl 16);
const PR_SUBJECT                                   = 
   (PT_TSTRING) or (($0037) shl 16);
const PR_SUBJECT_W                                 = 
   (PT_UNICODE) or (($0037) shl 16);
const PR_SUBJECT_A                                 = 
   (PT_STRING8) or (($0037) shl 16);
const PR_SUBJECT_IPM                               = 
   (PT_BINARY) or (($0038) shl 16);
const PR_CLIENT_SUBMIT_TIME                        = 
   (PT_SYSTIME) or (($0039) shl 16);
const PR_REPORT_NAME                               = 
   (PT_TSTRING) or (($003A) shl 16);
const PR_REPORT_NAME_W                             = 
   (PT_UNICODE) or (($003A) shl 16);
const PR_REPORT_NAME_A                             = 
   (PT_STRING8) or (($003A) shl 16);
const PR_SENT_REPRESENTING_SEARCH_KEY              = 
   (PT_BINARY) or (($003) shl 16);
const PR_X400_CONTENT_TYPE                         = 
   (PT_BINARY) or (($003C) shl 16);
const PR_SUBJECT_PREFIX                            = 
   (PT_TSTRING) or (($003D) shl 16);
const PR_SUBJECT_PREFIX_W                          = 
   (PT_UNICODE) or (($003D) shl 16);
const PR_SUBJECT_PREFIX_A                          = 
   (PT_STRING8) or (($003D) shl 16);
const PR_NON_RECEIPT_REASON                        = 
   (PT_LONG) or (($003E) shl 16);
const PR_RECEIVED_BY_ENTRYID                       = 
   (PT_BINARY) or (($003F) shl 16);
const PR_RECEIVED_BY_NAME                          = 
   (PT_TSTRING) or (($0040) shl 16);
const PR_RECEIVED_BY_NAME_W                        = 
   (PT_UNICODE) or (($0040) shl 16);
const PR_RECEIVED_BY_NAME_A                        = 
   (PT_STRING8) or (($0040) shl 16);
const PR_SENT_REPRESENTING_ENTRYID                 = 
   (PT_BINARY) or (($0041) shl 16);
const PR_SENT_REPRESENTING_NAME                    = 
   (PT_TSTRING) or (($0042) shl 16);
const PR_SENT_REPRESENTING_NAME_W                  = 
   (PT_UNICODE) or (($0042) shl 16);
const PR_SENT_REPRESENTING_NAME_A                  = 
   (PT_STRING8) or (($0042) shl 16);
const PR_RCVD_REPRESENTING_ENTRYID                 = 
   (PT_BINARY) or (($0043) shl 16);
const PR_RCVD_REPRESENTING_NAME                    = 
   (PT_TSTRING) or (($0044) shl 16);
const PR_RCVD_REPRESENTING_NAME_W                  = 
   (PT_UNICODE) or (($0044) shl 16);
const PR_RCVD_REPRESENTING_NAME_A                  = 
   (PT_STRING8) or (($0044) shl 16);
const PR_REPORT_ENTRYID                            = 
   (PT_BINARY) or (($0045) shl 16);
const PR_READ_RECEIPT_ENTRYID                      = 
   (PT_BINARY) or (($0046) shl 16);
const PR_MESSAGE_SUBMISSION_ID                     = 
   (PT_BINARY) or (($0047) shl 16);
const PR_PROVIDER_SUBMIT_TIME                      = 
   (PT_SYSTIME) or (($0048) shl 16);
const PR_ORIGINAL_SUBJECT                          = 
   (PT_TSTRING) or (($0049) shl 16);
const PR_ORIGINAL_SUBJECT_W                        = 
   (PT_UNICODE) or (($0049) shl 16);
const PR_ORIGINAL_SUBJECT_A                        = 
   (PT_STRING8) or (($0049) shl 16);
const PR_DISC_VAL                                  = 
   (PT_BOOLEAN) or (($004A) shl 16);
const PR_ORIG_MESSAGE_CLASS                        = 
   (PT_TSTRING) or (($004) shl 16);
const PR_ORIG_MESSAGE_CLASS_W                      = 
   (PT_UNICODE) or (($004) shl 16);
const PR_ORIG_MESSAGE_CLASS_A                      = 
   (PT_STRING8) or (($004) shl 16);
const PR_ORIGINAL_AUTHOR_ENTRYID                   = 
   (PT_BINARY) or (($004C) shl 16);
const PR_ORIGINAL_AUTHOR_NAME                      = 
   (PT_TSTRING) or (($004D) shl 16);
const PR_ORIGINAL_AUTHOR_NAME_W                    = 
   (PT_UNICODE) or (($004D) shl 16);
const PR_ORIGINAL_AUTHOR_NAME_A                    = 
   (PT_STRING8) or (($004D) shl 16);
const PR_ORIGINAL_SUBMIT_TIME                      = 
   (PT_SYSTIME) or (($004E) shl 16);
const PR_REPLY_RECIPIENT_ENTRIES                   = 
   (PT_BINARY) or (($004F) shl 16);
const PR_REPLY_RECIPIENT_NAMES                     = 
   (PT_TSTRING) or (($0050) shl 16);
const PR_REPLY_RECIPIENT_NAMES_W                   = 
   (PT_UNICODE) or (($0050) shl 16);
const PR_REPLY_RECIPIENT_NAMES_A                   = 
   (PT_STRING8) or (($0050) shl 16);

const PR_RECEIVED_BY_SEARCH_KEY                    = 
   (PT_BINARY) or (($0051) shl 16);
const PR_RCVD_REPRESENTING_SEARCH_KEY              = 
   (PT_BINARY) or (($0052) shl 16);
const PR_READ_RECEIPT_SEARCH_KEY                   = 
   (PT_BINARY) or (($0053) shl 16);
const PR_REPORT_SEARCH_KEY                         = 
   (PT_BINARY) or (($0054) shl 16);
const PR_ORIGINAL_DELIVERY_TIME                    = 
   (PT_SYSTIME) or (($0055) shl 16);
const PR_ORIGINAL_AUTHOR_SEARCH_KEY                = 
   (PT_BINARY) or (($0056) shl 16);

const PR_MESSAGE_TO_ME                             = 
   (PT_BOOLEAN) or (($0057) shl 16);
const PR_MESSAGE_CC_ME                             = 
   (PT_BOOLEAN) or (($0058) shl 16);
const PR_MESSAGE_RECIP_ME                          = 
   (PT_BOOLEAN) or (($0059) shl 16);

const PR_ORIGINAL_SENDER_NAME                      = 
   (PT_TSTRING) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_NAME_W                    = 
   (PT_UNICODE) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_NAME_A                    = 
   (PT_STRING8) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_ENTRYID                   = 
   (PT_BINARY) or (($005) shl 16);
const PR_ORIGINAL_SENDER_SEARCH_KEY                = 
   (PT_BINARY) or (($005C) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME           = 
   (PT_TSTRING) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME_W         = 
   (PT_UNICODE) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME_A         = 
   (PT_STRING8) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ENTRYID        =
   (PT_BINARY) or (($005E) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY     = 
   (PT_BINARY) or (($005F) shl 16);

const PR_START_DATE                                = 
   (PT_SYSTIME) or (($0060) shl 16);
const PR_END_DATE                                  = 
   (PT_SYSTIME) or (($0061) shl 16);
const PR_OWNER_APPT_ID                             = 
   (PT_LONG) or (($0062) shl 16);
const PR_RESPONSE_REQUESTED                        = 
   (PT_BOOLEAN) or (($0063) shl 16);

const PR_SENT_REPRESENTING_ADDRTYPE                = 
   (PT_TSTRING) or (($0064) shl 16);
const PR_SENT_REPRESENTING_ADDRTYPE_W              = 
   (PT_UNICODE) or (($0064) shl 16);
const PR_SENT_REPRESENTING_ADDRTYPE_A              = 
   (PT_STRING8) or (($0064) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS           = 
   (PT_TSTRING) or (($0065) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS_W         = 
   (PT_UNICODE) or (($0065) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS_A         =
   (PT_STRING8) or (($0065) shl 16);

const PR_ORIGINAL_SENDER_ADDRTYPE                  = 
   (PT_TSTRING) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_ADDRTYPE_W                = 
   (PT_UNICODE) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_ADDRTYPE_A                = 
   (PT_STRING8) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS             = 
   (PT_TSTRING) or (($0067) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS_W           = 
   (PT_UNICODE) or (($0067) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS_A           = 
   (PT_STRING8) or (($0067) shl 16);

const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE       = 
   (PT_TSTRING) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_W     = 
   (PT_UNICODE) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_A     = 
   (PT_STRING8) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS  = 
   (PT_TSTRING) or (($0069) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_W    =
   (PT_UNICODE) or (($0069) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_A    = 
   (PT_STRING8) or (($0069) shl 16);

const PR_CONVERSATION_TOPIC                        = 
   (PT_TSTRING) or (($0070) shl 16);
const PR_CONVERSATION_TOPIC_W                      = 
   (PT_UNICODE) or (($0070) shl 16);
const PR_CONVERSATION_TOPIC_A                      = 
   (PT_STRING8) or (($0070) shl 16);
const PR_CONVERSATION_INDEX                        = 
   (PT_BINARY) or (($0071) shl 16);

const PR_ORIGINAL_DISPLAY_BCC                      = 
   (PT_TSTRING) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_BCC_W                    = 
   (PT_UNICODE) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_BCC_A                    = 
   (PT_STRING8) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_CC                       = 
   (PT_TSTRING) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_CC_W                     = 
   (PT_UNICODE) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_CC_A                     =
   (PT_STRING8) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_TO                       = 
   (PT_TSTRING) or (($0074) shl 16);
const PR_ORIGINAL_DISPLAY_TO_W                     =
   (PT_UNICODE) or (($0074) shl 16);
const PR_ORIGINAL_DISPLAY_TO_A                     = 
   (PT_STRING8) or (($0074) shl 16);

const PR_RECEIVED_BY_ADDRTYPE                      = 
   (PT_TSTRING) or (($0075) shl 16);
const PR_RECEIVED_BY_ADDRTYPE_W                    = 
   (PT_UNICODE) or (($0075) shl 16);
const PR_RECEIVED_BY_ADDRTYPE_A                    = 
   (PT_STRING8) or (($0075) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS                 = 
   (PT_TSTRING) or (($0076) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS_W               = 
   (PT_UNICODE) or (($0076) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS_A               = 
   (PT_STRING8) or (($0076) shl 16);

const PR_RCVD_REPRESENTING_ADDRTYPE                = 
   (PT_TSTRING) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_ADDRTYPE_W              =
   (PT_UNICODE) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_ADDRTYPE_A              = 
   (PT_STRING8) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS           =
   (PT_TSTRING) or (($0078) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS_W         = 
   (PT_UNICODE) or (($0078) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS_A         = 
   (PT_STRING8) or (($0078) shl 16);

const PR_ORIGINAL_AUTHOR_ADDRTYPE                  = 
   (PT_TSTRING) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_ADDRTYPE_W                = 
   (PT_UNICODE) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_ADDRTYPE_A                = 
   (PT_STRING8) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS             = 
   (PT_TSTRING) or (($007A) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_W           = 
   (PT_UNICODE) or (($007A) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_A           = 
   (PT_STRING8) or (($007A) shl 16);

const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE        =
   (PT_TSTRING) or (($007) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_W      = 
   (PT_UNICODE) or (($007) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_A      =
   (PT_STRING8) or (($007) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS   = 
   (PT_TSTRING) or (($007C) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_W     = 
   (PT_UNICODE) or (($007C) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_A     = 
   (PT_STRING8) or (($007C) shl 16);

const PR_TRANSPORT_MESSAGE_HEADERS                 = 
  (PT_TSTRING) or (($007D) shl 16);
const PR_TRANSPORT_MESSAGE_HEADERS_W               = 
  (PT_UNICODE) or (($007D) shl 16);
const PR_TRANSPORT_MESSAGE_HEADERS_A               = 
  (PT_STRING8) or (($007D) shl 16);

const PR_DELEGATION                                = 
  (PT_BINARY) or (($007E) shl 16);

const PR_TNEF_CORRELATION_KEY                      = 
  (PT_BINARY) or (($007F) shl 16);



(*
 *  Message content properties
 *)

const PR_BODY                                      = 
   (PT_TSTRING) or (($1000) shl 16);
const PR_BODY_W                                    = 
   (PT_UNICODE) or (($1000) shl 16);
const PR_BODY_A                                    = 
   (PT_STRING8) or (($1000) shl 16);
const PR_REPORT_TEXT                               = 
   (PT_TSTRING) or (($1001) shl 16);
const PR_REPORT_TEXT_W                             = 
   (PT_UNICODE) or (($1001) shl 16);
const PR_REPORT_TEXT_A                             = 
   (PT_STRING8) or (($1001) shl 16);
const PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY       = 
   (PT_BINARY) or (($1002) shl 16);
const PR_REPORTING_DL_NAME                         = 
   (PT_BINARY) or (($1003) shl 16);
const PR_REPORTING_MTA_CERTIFICATE                 =
   (PT_BINARY) or (($1004) shl 16);

{  Removed PR_REPORT_ORIGIN_AUTHENTICATION_CHECK with DCR 3865, use PR_ORIGIN_CHECK }

const PR_RTF_SYNC_BODY_CRC                         = 
   (PT_LONG) or (($1006) shl 16);
const PR_RTF_SYNC_BODY_COUNT                       = 
   (PT_LONG) or (($1007) shl 16);
const PR_RTF_SYNC_BODY_TAG                         = 
   (PT_TSTRING) or (($1008) shl 16);
const PR_RTF_SYNC_BODY_TAG_W                       = 
   (PT_UNICODE) or (($1008) shl 16);
const PR_RTF_SYNC_BODY_TAG_A                       = 
   (PT_STRING8) or (($1008) shl 16);
const PR_RTF_COMPRESSED                            = 
   (PT_BINARY) or (($1009) shl 16);
const PR_RTF_SYNC_PREFIX_COUNT                     = 
   (PT_LONG) or (($1010) shl 16);
const PR_RTF_SYNC_TRAILING_COUNT                   = 
   (PT_LONG) or (($1011) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ENTRYID         = 
   (PT_BINARY) or (($1012) shl 16);

(*
 *  Reserved 0x1100-0x1200
 *)


(*
 *  Message recipient properties
 *)

const PR_CONTENT_INTEGRITY_CHECK                   = 
   (PT_BINARY) or (($0C00) shl 16);
const PR_EXPLICIT_CONVERSION                       = 
   (PT_LONG) or (($0C01) shl 16);
const PR_IPM_RETURN_REQUESTED                      = 
   (PT_BOOLEAN) or (($0C02) shl 16);
const PR_MESSAGE_TOKEN                             = 
   (PT_BINARY) or (($0C03) shl 16);
const PR_NDR_REASON_CODE                           = 
   (PT_LONG) or (($0C04) shl 16);
const PR_NDR_DIAG_CODE                             = 
   (PT_LONG) or (($0C05) shl 16);
const PR_NON_RECEIPT_NOTIFICATION_REQUESTED        = 
   (PT_BOOLEAN) or (($0C06) shl 16);
const PR_DELIVERY_POINT                            = 
   (PT_LONG) or (($0C07) shl 16);

const PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED  = 
   (PT_BOOLEAN) or (($0C08) shl 16);
const PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT  =
   (PT_BINARY) or (($0C09) shl 16);
const PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY     = 
   (PT_BOOLEAN) or (($0C0A) shl 16);
const PR_PHYSICAL_DELIVERY_MODE                    = 
   (PT_LONG) or (($0C0) shl 16);
const PR_PHYSICAL_DELIVERY_REPORT_REQUEST          = 
   (PT_LONG) or (($0C0C) shl 16);
const PR_PHYSICAL_FORWARDING_ADDRESS               = 
   (PT_BINARY) or (($0C0D) shl 16);
const PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED     = 
   (PT_BOOLEAN) or (($0C0E) shl 16);
const PR_PHYSICAL_FORWARDING_PROHIBITED            = 
   (PT_BOOLEAN) or (($0C0F) shl 16);
const PR_PHYSICAL_RENDITION_ATTRIBUTES             = 
   (PT_BINARY) or (($0C10) shl 16);
const PR_PROOF_OF_DELIVERY                         = 
   (PT_BINARY) or (($0C11) shl 16);
const PR_PROOF_OF_DELIVERY_REQUESTED               = 
   (PT_BOOLEAN) or (($0C12) shl 16);
const PR_RECIPIENT_CERTIFICATE                     =
   (PT_BINARY) or (($0C13) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE               = 
   (PT_TSTRING) or (($0C14) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE_W             =
   (PT_UNICODE) or (($0C14) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE_A             = 
   (PT_STRING8) or (($0C14) shl 16);
const PR_RECIPIENT_TYPE                            = 
   (PT_LONG) or (($0C15) shl 16);
const PR_REGISTERED_MAIL_TYPE                      = 
   (PT_LONG) or (($0C16) shl 16);
const PR_REPLY_REQUESTED                           = 
   (PT_BOOLEAN) or (($0C17) shl 16);
const PR_REQUESTED_DELIVERY_METHOD                 = 
   (PT_LONG) or (($0C18) shl 16);
const PR_SENDER_ENTRYID                            = 
   (PT_BINARY) or (($0C19) shl 16);
const PR_SENDER_NAME                               = 
   (PT_TSTRING) or (($0C1A) shl 16);
const PR_SENDER_NAME_W                             = 
   (PT_UNICODE) or (($0C1A) shl 16);
const PR_SENDER_NAME_A                             = 
   (PT_STRING8) or (($0C1A) shl 16);
const PR_SUPPLEMENTARY_INFO                        =
   (PT_TSTRING) or (($0C1) shl 16);
const PR_SUPPLEMENTARY_INFO_W                      = 
   (PT_UNICODE) or (($0C1) shl 16);
const PR_SUPPLEMENTARY_INFO_A                      =
   (PT_STRING8) or (($0C1) shl 16);
const PR_TYPE_OF_MTS_USER                          = 
   (PT_LONG) or (($0C1C) shl 16);
const PR_SENDER_SEARCH_KEY                         = 
   (PT_BINARY) or (($0C1D) shl 16);
const PR_SENDER_ADDRTYPE                           = 
   (PT_TSTRING) or (($0C1E) shl 16);
const PR_SENDER_ADDRTYPE_W                         = 
   (PT_UNICODE) or (($0C1E) shl 16);
const PR_SENDER_ADDRTYPE_A                         = 
   (PT_STRING8) or (($0C1E) shl 16);
const PR_SENDER_EMAIL_ADDRESS                      = 
   (PT_TSTRING) or (($0C1F) shl 16);
const PR_SENDER_EMAIL_ADDRESS_W                    = 
   (PT_UNICODE) or (($0C1F) shl 16);
const PR_SENDER_EMAIL_ADDRESS_A                    = 
   (PT_STRING8) or (($0C1F) shl 16);

(*
 *  Message non-transmittable properties
 *)

(*
 * The two tags, PR_MESSAGE_RECIPIENTS and PR_MESSAGE_ATTACHMENTS,
 * are to be used in the exclude list passed to
 * IMessage::CopyTo when the caller wants either the recipients or attachments
 * of the message to not get copied.  It is also used in the ProblemArray
 * return from IMessage::CopyTo when an error is encountered copying them
 *)

const PR_CURRENT_VERSION                           = 
   (PT_I8) or (($0E00) shl 16);
const PR_DELETE_AFTER_SUBMIT                       = 
   (PT_BOOLEAN) or (($0E01) shl 16);
const PR_DISPLAY_BCC                               = 
   (PT_TSTRING) or (($0E02) shl 16);
const PR_DISPLAY_BCC_W                             = 
   (PT_UNICODE) or (($0E02) shl 16);
const PR_DISPLAY_BCC_A                             = 
   (PT_STRING8) or (($0E02) shl 16);
const PR_DISPLAY_CC                                = 
   (PT_TSTRING) or (($0E03) shl 16);
const PR_DISPLAY_CC_W                              = 
   (PT_UNICODE) or (($0E03) shl 16);
const PR_DISPLAY_CC_A                              = 
   (PT_STRING8) or (($0E03) shl 16);
const PR_DISPLAY_TO                                = 
   (PT_TSTRING) or (($0E04) shl 16);
const PR_DISPLAY_TO_W                              = 
   (PT_UNICODE) or (($0E04) shl 16);
const PR_DISPLAY_TO_A                              = 
   (PT_STRING8) or (($0E04) shl 16);
const PR_PARENT_DISPLAY                            = 
   (PT_TSTRING) or (($0E05) shl 16);
const PR_PARENT_DISPLAY_W                          = 
   (PT_UNICODE) or (($0E05) shl 16);
const PR_PARENT_DISPLAY_A                          = 
   (PT_STRING8) or (($0E05) shl 16);
const PR_MESSAGE_DELIVERY_TIME                     = 
   (PT_SYSTIME) or (($0E06) shl 16);
const PR_MESSAGE_FLAGS                             = 
   (PT_LONG) or (($0E07) shl 16);
const PR_MESSAGE_SIZE                              = 
   (PT_LONG) or (($0E08) shl 16);
const PR_PARENT_ENTRYID                            = 
   (PT_BINARY) or (($0E09) shl 16);
const PR_SENTMAIL_ENTRYID                          = 
   (PT_BINARY) or (($0E0A) shl 16);
const PR_CORRELATE                                 = 
   (PT_BOOLEAN) or (($0E0C) shl 16);
const PR_CORRELATE_MTSID                           = 
   (PT_BINARY) or (($0E0D) shl 16);
const PR_DISCRETE_VALUES                           = 
   (PT_BOOLEAN) or (($0E0E) shl 16);
const PR_RESPONSIBILITY                            = 
   (PT_BOOLEAN) or (($0E0F) shl 16);
const PR_SPOOLER_STATUS                            = 
   (PT_LONG) or (($0E10) shl 16);
const PR_TRANSPORT_STATUS                          = 
   (PT_LONG) or (($0E11) shl 16);
const PR_MESSAGE_RECIPIENTS                        = 
   (PT_OBJECT) or (($0E12) shl 16);
const PR_MESSAGE_ATTACHMENTS                       = 
   (PT_OBJECT) or (($0E13) shl 16);
const PR_SUBMIT_FLAGS                              = 
   (PT_LONG) or (($0E14) shl 16);
const PR_RECIPIENT_STATUS                          = 
   (PT_LONG) or (($0E15) shl 16);
const PR_TRANSPORT_KEY                             = 
   (PT_LONG) or (($0E16) shl 16);
const PR_MSG_STATUS                                = 
   (PT_LONG) or (($0E17) shl 16);
const PR_MESSAGE_DOWNLOAD_TIME                     = 
   (PT_LONG) or (($0E18) shl 16);
const PR_CREATION_VERSION                          = 
   (PT_I8) or (($0E19) shl 16);
const PR_MODIFY_VERSION                            = 
   (PT_I8) or (($0E1A) shl 16);
const PR_HASATTACH                                 = 
   (PT_BOOLEAN) or (($0E1) shl 16);
const PR_BODY_CRC                                  = 
   (PT_LONG) or (($0E1C) shl 16);
const PR_NORMALIZED_SUBJECT                        = 
   (PT_TSTRING) or (($0E1D) shl 16);
const PR_NORMALIZED_SUBJECT_W                      = 
   (PT_UNICODE) or (($0E1D) shl 16);
const PR_NORMALIZED_SUBJECT_A                      = 
   (PT_STRING8) or (($0E1D) shl 16);
const PR_RTF_IN_SYNC                               = 
   (PT_BOOLEAN) or (($0E1F) shl 16);
const PR_ATTACH_SIZE                               = 
   (PT_LONG) or (($0E20) shl 16);
const PR_ATTACH_NUM                                = 
   (PT_LONG) or (($0E21) shl 16);
const PR_PREPROCESS                                = 
   (PT_BOOLEAN) or (($0E22) shl 16);

{ PR_ORIGINAL_DISPLAY_TO, _CC, and _BCC moved to transmittible range 03/09/95 }

const PR_ORIGINATING_MTA_CERTIFICATE               =
   (PT_BINARY) or (($0E25) shl 16);
const PR_PROOF_OF_SUBMISSION                       = 
   (PT_BINARY) or (($0E26) shl 16);


(*
 * The range of non-message and non-recipient property IDs (0x3000 - 0x3FFF) is
 * further broken down into ranges to make assigning new property IDs easier.
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  3000    32FF    MAPI_defined common property
 *  3200    33FF    MAPI_defined form property
 *  3400    35FF    MAPI_defined message store property
 *  3600    36FF    MAPI_defined Folder or AB Container property
 *  3700    38FF    MAPI_defined attachment property
 *  3900    39FF    MAPI_defined address book property
 *  3A00    3BFF    MAPI_defined mailuser property
 *  3C00    3CFF    MAPI_defined DistList property
 *  3D00    3DFF    MAPI_defined Profile Section property
 *  3E00    3EFF    MAPI_defined Status property
 *  3F00    3FFF    MAPI_defined display table property
 *)

(*
 *  Properties common to numerous MAPI objects.
 *
 *  Those properties that can appear on messages are in the
 *  non-transmittable range for messages. They start at the high
 *  end of that range and work down.
 *
 *  Properties that never appear on messages are defined in the common
 *  property range (see above).
 *)

(*
 * properties that are common to multiple objects (including message objects)
 * -- these ids are in the non-transmittable range
 *)

const PR_ENTRYID                                   = 
   (PT_BINARY) or (($0FFF) shl 16);
const PR_OBJECT_TYPE                               = 
   (PT_LONG) or (($0FFE) shl 16);
const PR_ICON                                      = 
   (PT_BINARY) or (($0FFD) shl 16);
const PR_MINI_ICON                                 = 
   (PT_BINARY) or (($0FFC) shl 16);
const PR_STORE_ENTRYID                             = 
   (PT_BINARY) or (($0FF) shl 16);
const PR_STORE_RECORD_KEY                          = 
   (PT_BINARY) or (($0FFA) shl 16);
const PR_RECORD_KEY                                = 
   (PT_BINARY) or (($0FF9) shl 16);
const PR_MAPPING_SIGNATURE                         = 
   (PT_BINARY) or (($0FF8) shl 16);
const PR_ACCESS_LEVEL                              = 
   (PT_LONG) or (($0FF7) shl 16);
const PR_INSTANCE_KEY                              = 
   (PT_BINARY) or (($0FF6) shl 16);
const PR_ROW_TYPE                                  = 
   (PT_LONG) or (($0FF5) shl 16);
const PR_ACCESS                                    = 
   (PT_LONG) or (($0FF4) shl 16);

(*
 * properties that are common to multiple objects (usually not including message objects)
 * -- these ids are in the transmittable range
 *)

const PR_ROWID                                     = 
   (PT_LONG) or (($3000) shl 16);
const PR_DISPLAY_NAME                              = 
   (PT_TSTRING) or (($3001) shl 16);
const PR_DISPLAY_NAME_W                            = 
   (PT_UNICODE) or (($3001) shl 16);
const PR_DISPLAY_NAME_A                            = 
   (PT_STRING8) or (($3001) shl 16);
const PR_ADDRTYPE                                  = 
   (PT_TSTRING) or (($3002) shl 16);
const PR_ADDRTYPE_W                                = 
   (PT_UNICODE) or (($3002) shl 16);
const PR_ADDRTYPE_A                                = 
   (PT_STRING8) or (($3002) shl 16);
const PR_EMAIL_ADDRESS                             = 
   (PT_TSTRING) or (($3003) shl 16);
const PR_EMAIL_ADDRESS_W                           = 
   (PT_UNICODE) or (($3003) shl 16);
const PR_EMAIL_ADDRESS_A                           = 
   (PT_STRING8) or (($3003) shl 16);
const PR_COMMENT                                   = 
   (PT_TSTRING) or (($3004) shl 16);
const PR_COMMENT_W                                 = 
   (PT_UNICODE) or (($3004) shl 16);
const PR_COMMENT_A                                 = 
   (PT_STRING8) or (($3004) shl 16);
const PR_DEPTH                                     = 
   (PT_LONG) or (($3005) shl 16);
const PR_PROVIDER_DISPLAY                          = 
   (PT_TSTRING) or (($3006) shl 16);
const PR_PROVIDER_DISPLAY_W                        = 
   (PT_UNICODE) or (($3006) shl 16);
const PR_PROVIDER_DISPLAY_A                        = 
   (PT_STRING8) or (($3006) shl 16);
const PR_CREATION_TIME                             = 
   (PT_SYSTIME) or (($3007) shl 16);
const PR_LAST_MODIFICATION_TIME                    = 
   (PT_SYSTIME) or (($3008) shl 16);
const PR_RESOURCE_FLAGS                            = 
   (PT_LONG) or (($3009) shl 16);
const PR_PROVIDER_DLL_NAME                         = 
   (PT_TSTRING) or (($300A) shl 16);
const PR_PROVIDER_DLL_NAME_W                       = 
   (PT_UNICODE) or (($300A) shl 16);
const PR_PROVIDER_DLL_NAME_A                       = 
   (PT_STRING8) or (($300A) shl 16);
const PR_SEARCH_KEY                                = 
   (PT_BINARY) or (($300) shl 16);
const PR_PROVIDER_UID                              = 
   (PT_BINARY) or (($300C) shl 16);
const PR_PROVIDER_ORDINAL                          = 
   (PT_LONG) or (($300D) shl 16);

(*
 *  MAPI Form properties
 *)
const PR_FORM_VERSION                              = 
  (PT_TSTRING) or (($3301) shl 16);
const PR_FORM_VERSION_W                            = 
  (PT_UNICODE) or (($3301) shl 16);
const PR_FORM_VERSION_A                            = 
  (PT_STRING8) or (($3301) shl 16);
const PR_FORM_CLSID                                = 
  (PT_CLSID) or (($3302) shl 16);
const PR_FORM_CONTACT_NAME                         = 
  (PT_TSTRING) or (($3303) shl 16);
const PR_FORM_CONTACT_NAME_W                       = 
  (PT_UNICODE) or (($3303) shl 16);
const PR_FORM_CONTACT_NAME_A                       = 
  (PT_STRING8) or (($3303) shl 16);
const PR_FORM_CATEGORY                             = 
  (PT_TSTRING) or (($3304) shl 16);
const PR_FORM_CATEGORY_W                           = 
  (PT_UNICODE) or (($3304) shl 16);
const PR_FORM_CATEGORY_A                           = 
  (PT_STRING8) or (($3304) shl 16);
const PR_FORM_CATEGORY_SUB                         = 
  (PT_TSTRING) or (($3305) shl 16);
const PR_FORM_CATEGORY_SUB_W                       = 
  (PT_UNICODE) or (($3305) shl 16);
const PR_FORM_CATEGORY_SUB_A                       = 
  (PT_STRING8) or (($3305) shl 16);
const PR_FORM_HOST_MAP                             = 
  (PT_MV_LONG) or (($3306) shl 16);
const PR_FORM_HIDDEN                               = 
  (PT_BOOLEAN) or (($3307) shl 16);
const PR_FORM_DESIGNER_NAME                        = 
  (PT_TSTRING) or (($3308) shl 16);
const PR_FORM_DESIGNER_NAME_W                      = 
  (PT_UNICODE) or (($3308) shl 16);
const PR_FORM_DESIGNER_NAME_A                      = 
  (PT_STRING8) or (($3308) shl 16);
const PR_FORM_DESIGNER_GUID                        = 
  (PT_CLSID) or (($3309) shl 16);
const PR_FORM_MESSAGE_BEHAVIOR                     = 
  (PT_LONG) or (($330A) shl 16);

(*
 *  Message store properties
 *)

const PR_DEFAULT_STORE                             = 
   (PT_BOOLEAN) or (($3400) shl 16);
const PR_STORE_SUPPORT_MASK                        = 
   (PT_LONG) or (($340D) shl 16);
const PR_STORE_STATE                               = 
   (PT_LONG) or (($340E) shl 16);

const PR_IPM_SUBTREE_SEARCH_KEY                    = 
   (PT_BINARY) or (($3410) shl 16);
const PR_IPM_OUTBOX_SEARCH_KEY                     = 
   (PT_BINARY) or (($3411) shl 16);
const PR_IPM_WASTEBASKET_SEARCH_KEY                = 
   (PT_BINARY) or (($3412) shl 16);
const PR_IPM_SENTMAIL_SEARCH_KEY                   = 
   (PT_BINARY) or (($3413) shl 16);
const PR_MDB_PROVIDER                              = 
   (PT_BINARY) or (($3414) shl 16);
const PR_RECEIVE_FOLDER_SETTINGS                   = 
   (PT_OBJECT) or (($3415) shl 16);

const PR_VALID_FOLDER_MASK                         =
   (PT_LONG) or (($35DF) shl 16);
const PR_IPM_SUBTREE_ENTRYID                       = 
   (PT_BINARY) or (($35E0) shl 16);

const PR_IPM_OUTBOX_ENTRYID                        = 
   (PT_BINARY) or (($35E2) shl 16);
const PR_IPM_WASTEBASKET_ENTRYID                   = 
   (PT_BINARY) or (($35E3) shl 16);
const PR_IPM_SENTMAIL_ENTRYID                      = 
   (PT_BINARY) or (($35E4) shl 16);
const PR_VIEWS_ENTRYID                             = 
   (PT_BINARY) or (($35E5) shl 16);
const PR_COMMON_VIEWS_ENTRYID                      = 
   (PT_BINARY) or (($35E6) shl 16);
const PR_FINDER_ENTRYID                            = 
   (PT_BINARY) or (($35E7) shl 16);

{ Proptags 0x35E8-0x35FF reserved for folders "guaranteed" by PR_VALID_FOLDER_MASK }


(*
 *  Folder and AB Container properties
 *)

const PR_CONTAINER_FLAGS                           = 
   (PT_LONG) or (($3600) shl 16);
const PR_FOLDER_TYPE                               = 
   (PT_LONG) or (($3601) shl 16);
const PR_CONTENT_COUNT                             = 
   (PT_LONG) or (($3602) shl 16);
const PR_CONTENT_UNREAD                            = 
   (PT_LONG) or (($3603) shl 16);
const PR_CREATE_TEMPLATES                          = 
   (PT_OBJECT) or (($3604) shl 16);
const PR_DETAILS_TABLE                             = 
   (PT_OBJECT) or (($3605) shl 16);
const PR_SEARCH                                    = 
   (PT_OBJECT) or (($3607) shl 16);
const PR_SELECTABLE                                = 
   (PT_BOOLEAN) or (($3609) shl 16);
const PR_SUBFOLDERS                                = 
   (PT_BOOLEAN) or (($360A) shl 16);
const PR_STATUS                                    = 
   (PT_LONG) or (($360) shl 16);
const PR_ANR                                       = 
   (PT_TSTRING) or (($360C) shl 16);
const PR_ANR_W                                     = 
   (PT_UNICODE) or (($360C) shl 16);
const PR_ANR_A                                     = 
   (PT_STRING8) or (($360C) shl 16);
const PR_CONTENTS_SORT_ORDER                       = 
   (PT_MV_LONG) or (($360D) shl 16);
const PR_CONTAINER_HIERARCHY                       = 
   (PT_OBJECT) or (($360E) shl 16);
const PR_CONTAINER_CONTENTS                        = 
   (PT_OBJECT) or (($360F) shl 16);
const PR_FOLDER_ASSOCIATED_CONTENTS                = 
   (PT_OBJECT) or (($3610) shl 16);
const PR_DEF_CREATE_DL                             = 
   (PT_BINARY) or (($3611) shl 16);
const PR_DEF_CREATE_MAILUSER                       = 
   (PT_BINARY) or (($3612) shl 16);
const PR_CONTAINER_CLASS                           = 
   (PT_TSTRING) or (($3613) shl 16);
const PR_CONTAINER_CLASS_W                         = 
   (PT_UNICODE) or (($3613) shl 16);
const PR_CONTAINER_CLASS_A                         = 
   (PT_STRING8) or (($3613) shl 16);
const PR_CONTAINER_MODIFY_VERSION                  = 
   (PT_I8) or (($3614) shl 16);
const PR_AB_PROVIDER_ID                            = 
   (PT_BINARY) or (($3615) shl 16);
const PR_DEFAULT_VIEW_ENTRYID                      = 
   (PT_BINARY) or (($3616) shl 16);
const PR_ASSOC_CONTENT_COUNT                       = 
   (PT_LONG) or (($3617) shl 16);

{ Reserved 0x36C0-0x36FF }

(*
 *  Attachment properties
 *)

const PR_ATTACHMENT_X400_PARAMETERS                = 
   (PT_BINARY) or (($3700) shl 16);
const PR_ATTACH_DATA_OBJ                           = 
   (PT_OBJECT) or (($3701) shl 16);
const PR_ATTACH_DATA_BIN                           = 
   (PT_BINARY) or (($3701) shl 16);
const PR_ATTACH_ENCODING                           = 
   (PT_BINARY) or (($3702) shl 16);
const PR_ATTACH_EXTENSION                          = 
   (PT_TSTRING) or (($3703) shl 16);
const PR_ATTACH_EXTENSION_W                        = 
   (PT_UNICODE) or (($3703) shl 16);
const PR_ATTACH_EXTENSION_A                        =
   (PT_STRING8) or (($3703) shl 16);
const PR_ATTACH_FILENAME                           = 
   (PT_TSTRING) or (($3704) shl 16);
const PR_ATTACH_FILENAME_W                         = 
   (PT_UNICODE) or (($3704) shl 16);
const PR_ATTACH_FILENAME_A                         = 
   (PT_STRING8) or (($3704) shl 16);
const PR_ATTACH_METHOD                             = 
   (PT_LONG) or (($3705) shl 16);
const PR_ATTACH_LONG_FILENAME                      = 
   (PT_TSTRING) or (($3707) shl 16);
const PR_ATTACH_LONG_FILENAME_W                    = 
   (PT_UNICODE) or (($3707) shl 16);
const PR_ATTACH_LONG_FILENAME_A                    = 
   (PT_STRING8) or (($3707) shl 16);
const PR_ATTACH_PATHNAME                           = 
   (PT_TSTRING) or (($3708) shl 16);
const PR_ATTACH_PATHNAME_W                         = 
   (PT_UNICODE) or (($3708) shl 16);
const PR_ATTACH_PATHNAME_A                         = 
   (PT_STRING8) or (($3708) shl 16);
const PR_ATTACH_RENDERING                          = 
   (PT_BINARY) or (($3709) shl 16);
const PR_ATTACH_TAG                                =
   (PT_BINARY) or (($370A) shl 16);
const PR_RENDERING_POSITION                        = 
   (PT_LONG) or (($370) shl 16);
const PR_ATTACH_TRANSPORT_NAME                     = 
   (PT_TSTRING) or (($370C) shl 16);
const PR_ATTACH_TRANSPORT_NAME_W                   = 
   (PT_UNICODE) or (($370C) shl 16);
const PR_ATTACH_TRANSPORT_NAME_A                   = 
   (PT_STRING8) or (($370C) shl 16);
const PR_ATTACH_LONG_PATHNAME                      = 
   (PT_TSTRING) or (($370D) shl 16);
const PR_ATTACH_LONG_PATHNAME_W                    = 
   (PT_UNICODE) or (($370D) shl 16);
const PR_ATTACH_LONG_PATHNAME_A                    = 
   (PT_STRING8) or (($370D) shl 16);
const PR_ATTACH_MIME_TAG                           = 
   (PT_TSTRING) or (($370E) shl 16);
const PR_ATTACH_MIME_TAG_W                         = 
   (PT_UNICODE) or (($370E) shl 16);
const PR_ATTACH_MIME_TAG_A                         = 
   (PT_STRING8) or (($370E) shl 16);
const PR_ATTACH_ADDITIONAL_INFO                    = 
   (PT_BINARY) or (($370F) shl 16);

(*
 *  AB Object properties
 *)

const PR_DISPLAY_TYPE                              = 
   (PT_LONG) or (($3900) shl 16);
const PR_TEMPLATEID                                = 
   (PT_BINARY) or (($3902) shl 16);
const PR_PRIMARY_CAPABILITY                        = 
   (PT_BINARY) or (($3904) shl 16);


(*
 *  Mail user properties
 *)
const PR_7BIT_DISPLAY_NAME                         = 
   (PT_STRING8) or (($39FF) shl 16);
const PR_ACCOUNT                                   = 
   (PT_TSTRING) or (($3A00) shl 16);
const PR_ACCOUNT_W                                 = 
   (PT_UNICODE) or (($3A00) shl 16);
const PR_ACCOUNT_A                                 = 
   (PT_STRING8) or (($3A00) shl 16);
const PR_ALTERNATE_RECIPIENT                       =
   (PT_BINARY) or (($3A01) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER                 = 
   (PT_TSTRING) or (($3A02) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER_W               = 
   (PT_UNICODE) or (($3A02) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A02) shl 16);
const PR_CONVERSION_PROHIBITED                     = 
   (PT_BOOLEAN) or (($3A03) shl 16);
const PR_DISCLOSE_RECIPIENTS                       = 
   (PT_BOOLEAN) or (($3A04) shl 16);
const PR_GENERATION                                = 
   (PT_TSTRING) or (($3A05) shl 16);
const PR_GENERATION_W                              = 
   (PT_UNICODE) or (($3A05) shl 16);
const PR_GENERATION_A                              = 
   (PT_STRING8) or (($3A05) shl 16);
const PR_GIVEN_NAME                                = 
   (PT_TSTRING) or (($3A06) shl 16);
const PR_GIVEN_NAME_W                              = 
   (PT_UNICODE) or (($3A06) shl 16);
const PR_GIVEN_NAME_A                              = 
   (PT_STRING8) or (($3A06) shl 16);
const PR_GOVERNMENT_ID_NUMBER                      =
   (PT_TSTRING) or (($3A07) shl 16);
const PR_GOVERNMENT_ID_NUMBER_W                    = 
   (PT_UNICODE) or (($3A07) shl 16);
const PR_GOVERNMENT_ID_NUMBER_A                    = 
   (PT_STRING8) or (($3A07) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER                 = 
   (PT_TSTRING) or (($3A08) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER_W               = 
   (PT_UNICODE) or (($3A08) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A08) shl 16);
const PR_OFFICE_TELEPHONE_NUMBER                   = PR_BUSINESS_TELEPHONE_NUMBER;
const PR_OFFICE_TELEPHONE_NUMBER_W                 = PR_BUSINESS_TELEPHONE_NUMBER_W;
const PR_OFFICE_TELEPHONE_NUMBER_A                 = PR_BUSINESS_TELEPHONE_NUMBER_A;
const PR_HOME_TELEPHONE_NUMBER                     = 
   (PT_TSTRING) or (($3A09) shl 16);
const PR_HOME_TELEPHONE_NUMBER_W                   = 
   (PT_UNICODE) or (($3A09) shl 16);
const PR_HOME_TELEPHONE_NUMBER_A                   = 
   (PT_STRING8) or (($3A09) shl 16);
const PR_INITIALS                                  = 
   (PT_TSTRING) or (($3A0A) shl 16);
const PR_INITIALS_W                                = 
   (PT_UNICODE) or (($3A0A) shl 16);
const PR_INITIALS_A                                = 
   (PT_STRING8) or (($3A0A) shl 16);
const PR_KEYWORD                                   = 
   (PT_TSTRING) or (($3A0) shl 16);
const PR_KEYWORD_W                                 = 
   (PT_UNICODE) or (($3A0) shl 16);
const PR_KEYWORD_A                                 = 
   (PT_STRING8) or (($3A0) shl 16);
const PR_LANGUAGE                                  = 
   (PT_TSTRING) or (($3A0C) shl 16);
const PR_LANGUAGE_W                                = 
   (PT_UNICODE) or (($3A0C) shl 16);
const PR_LANGUAGE_A                                = 
   (PT_STRING8) or (($3A0C) shl 16);
const PR_LOCATION                                  = 
   (PT_TSTRING) or (($3A0D) shl 16);
const PR_LOCATION_W                                = 
   (PT_UNICODE) or (($3A0D) shl 16);
const PR_LOCATION_A                                = 
   (PT_STRING8) or (($3A0D) shl 16);
const PR_MAIL_PERMISSION                           = 
   (PT_BOOLEAN) or (($3A0E) shl 16);
const PR_MHS_COMMON_NAME                           = 
   (PT_TSTRING) or (($3A0F) shl 16);
const PR_MHS_COMMON_NAME_W                         = 
   (PT_UNICODE) or (($3A0F) shl 16);
const PR_MHS_COMMON_NAME_A                         = 
   (PT_STRING8) or (($3A0F) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER                  = 
   (PT_TSTRING) or (($3A10) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER_W                = 
   (PT_UNICODE) or (($3A10) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER_A                = 
   (PT_STRING8) or (($3A10) shl 16);
const PR_SURNAME                                   = 
   (PT_TSTRING) or (($3A11) shl 16);
const PR_SURNAME_W                                 = 
   (PT_UNICODE) or (($3A11) shl 16);
const PR_SURNAME_A                                 = 
   (PT_STRING8) or (($3A11) shl 16);
const PR_ORIGINAL_ENTRYID                          = 
   (PT_BINARY) or (($3A12) shl 16);
const PR_ORIGINAL_DISPLAY_NAME                     = 
   (PT_TSTRING) or (($3A13) shl 16);
const PR_ORIGINAL_DISPLAY_NAME_W                   = 
   (PT_UNICODE) or (($3A13) shl 16);
const PR_ORIGINAL_DISPLAY_NAME_A                   = 
   (PT_STRING8) or (($3A13) shl 16);
const PR_ORIGINAL_SEARCH_KEY                       = 
   (PT_BINARY) or (($3A14) shl 16);
const PR_POSTAL_ADDRESS                            = 
   (PT_TSTRING) or (($3A15) shl 16);
const PR_POSTAL_ADDRESS_W                          = 
   (PT_UNICODE) or (($3A15) shl 16);
const PR_POSTAL_ADDRESS_A                          = 
   (PT_STRING8) or (($3A15) shl 16);
const PR_COMPANY_NAME                              = 
   (PT_TSTRING) or (($3A16) shl 16);
const PR_COMPANY_NAME_W                            = 
   (PT_UNICODE) or (($3A16) shl 16);
const PR_COMPANY_NAME_A                            = 
   (PT_STRING8) or (($3A16) shl 16);
const PR_TITLE                                     = 
   (PT_TSTRING) or (($3A17) shl 16);
const PR_TITLE_W                                   = 
   (PT_UNICODE) or (($3A17) shl 16);
const PR_TITLE_A                                   = 
   (PT_STRING8) or (($3A17) shl 16);
const PR_DEPARTMENT_NAME                           = 
   (PT_TSTRING) or (($3A18) shl 16);
const PR_DEPARTMENT_NAME_W                         = 
   (PT_UNICODE) or (($3A18) shl 16);
const PR_DEPARTMENT_NAME_A                         = 
   (PT_STRING8) or (($3A18) shl 16);
const PR_OFFICE_LOCATION                           = 
   (PT_TSTRING) or (($3A19) shl 16);
const PR_OFFICE_LOCATION_W                         = 
   (PT_UNICODE) or (($3A19) shl 16);
const PR_OFFICE_LOCATION_A                         = 
   (PT_STRING8) or (($3A19) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER                  = 
   (PT_TSTRING) or (($3A1A) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER_W                = 
   (PT_UNICODE) or (($3A1A) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER_A                = 
   (PT_STRING8) or (($3A1A) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER                = 
   (PT_TSTRING) or (($3A1) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER_W              = 
   (PT_UNICODE) or (($3A1) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER_A              = 
   (PT_STRING8) or (($3A1) shl 16);
const PR_OFFICE2_TELEPHONE_NUMBER                  = PR_BUSINESS2_TELEPHONE_NUMBER;
const PR_OFFICE2_TELEPHONE_NUMBER_W                = PR_BUSINESS2_TELEPHONE_NUMBER_W;
const PR_OFFICE2_TELEPHONE_NUMBER_A                = PR_BUSINESS2_TELEPHONE_NUMBER_A;
const PR_MOBILE_TELEPHONE_NUMBER                   =
   (PT_TSTRING) or (($3A1C) shl 16);
const PR_MOBILE_TELEPHONE_NUMBER_W                 = 
   (PT_UNICODE) or (($3A1C) shl 16);
const PR_MOBILE_TELEPHONE_NUMBER_A                 = 
   (PT_STRING8) or (($3A1C) shl 16);
const PR_CELLULAR_TELEPHONE_NUMBER                 = PR_MOBILE_TELEPHONE_NUMBER;
const PR_CELLULAR_TELEPHONE_NUMBER_W               = PR_MOBILE_TELEPHONE_NUMBER_W;
const PR_CELLULAR_TELEPHONE_NUMBER_A               = PR_MOBILE_TELEPHONE_NUMBER_A;
const PR_RADIO_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A1D) shl 16);
const PR_RADIO_TELEPHONE_NUMBER_W                  = 
   (PT_UNICODE) or (($3A1D) shl 16);
const PR_RADIO_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A1D) shl 16);
const PR_CAR_TELEPHONE_NUMBER                      = 
   (PT_TSTRING) or (($3A1E) shl 16);
const PR_CAR_TELEPHONE_NUMBER_W                    = 
   (PT_UNICODE) or (($3A1E) shl 16);
const PR_CAR_TELEPHONE_NUMBER_A                    = 
   (PT_STRING8) or (($3A1E) shl 16);
const PR_OTHER_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A1F) shl 16);
const PR_OTHER_TELEPHONE_NUMBER_W                  = 
   (PT_UNICODE) or (($3A1F) shl 16);
const PR_OTHER_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A1F) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME                 = 
   (PT_TSTRING) or (($3A20) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME_W               = 
   (PT_UNICODE) or (($3A20) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME_A               = 
   (PT_STRING8) or (($3A20) shl 16);
const PR_PAGER_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A21) shl 16);
const PR_PAGER_TELEPHONE_NUMBER_W                  = 
   (PT_UNICODE) or (($3A21) shl 16);
const PR_PAGER_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A21) shl 16);
const PR_BEEPER_TELEPHONE_NUMBER                   = PR_PAGER_TELEPHONE_NUMBER;
const PR_BEEPER_TELEPHONE_NUMBER_W                 = PR_PAGER_TELEPHONE_NUMBER_W;
const PR_BEEPER_TELEPHONE_NUMBER_A                 = PR_PAGER_TELEPHONE_NUMBER_A;
const PR_USER_CERTIFICATE                          = 
   (PT_BINARY) or (($3A22) shl 16);
const PR_PRIMARY_FAX_NUMBER                        = 
   (PT_TSTRING) or (($3A23) shl 16);
const PR_PRIMARY_FAX_NUMBER_W                      = 
   (PT_UNICODE) or (($3A23) shl 16);
const PR_PRIMARY_FAX_NUMBER_A                      =
   (PT_STRING8) or (($3A23) shl 16);
const PR_BUSINESS_FAX_NUMBER                       = 
   (PT_TSTRING) or (($3A24) shl 16);
const PR_BUSINESS_FAX_NUMBER_W                     = 
   (PT_UNICODE) or (($3A24) shl 16);
const PR_BUSINESS_FAX_NUMBER_A                     = 
   (PT_STRING8) or (($3A24) shl 16);
const PR_HOME_FAX_NUMBER                           = 
   (PT_TSTRING) or (($3A25) shl 16);
const PR_HOME_FAX_NUMBER_W                         = 
   (PT_UNICODE) or (($3A25) shl 16);
const PR_HOME_FAX_NUMBER_A                         = 
   (PT_STRING8) or (($3A25) shl 16);
const PR_COUNTRY                                   = 
   (PT_TSTRING) or (($3A26) shl 16);
const PR_COUNTRY_W                                 = 
   (PT_UNICODE) or (($3A26) shl 16);
const PR_COUNTRY_A                                 = 
   (PT_STRING8) or (($3A26) shl 16);
const PR_BUSINESS_ADDRESS_COUNTRY                  = PR_COUNTRY;
const PR_BUSINESS_ADDRESS_COUNTRY_W                = PR_COUNTRY_W;
const PR_BUSINESS_ADDRESS_COUNTRY_A                = PR_COUNTRY_A;

const PR_LOCALITY                                  =
   (PT_TSTRING) or (($3A27) shl 16);
const PR_LOCALITY_W                                = 
   (PT_UNICODE) or (($3A27) shl 16);
const PR_LOCALITY_A                                = 
   (PT_STRING8) or (($3A27) shl 16);
const PR_BUSINESS_ADDRESS_CITY                     = PR_LOCALITY;
const PR_BUSINESS_ADDRESS_CITY_W                   = PR_LOCALITY_W;
const PR_BUSINESS_ADDRESS_CITY_A                   = PR_LOCALITY_A;

const PR_STATE_OR_PROVINCE                         = 
   (PT_TSTRING) or (($3A28) shl 16);
const PR_STATE_OR_PROVINCE_W                       = 
   (PT_UNICODE) or (($3A28) shl 16);
const PR_STATE_OR_PROVINCE_A                       = 
   (PT_STRING8) or (($3A28) shl 16);
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE        = PR_STATE_OR_PROVINCE;
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE_W      = PR_STATE_OR_PROVINCE_W;
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE_A      = PR_STATE_OR_PROVINCE_A;

const PR_STREET_ADDRESS                            = 
   (PT_TSTRING) or (($3A29) shl 16);
const PR_STREET_ADDRESS_W                          = 
   (PT_UNICODE) or (($3A29) shl 16);
const PR_STREET_ADDRESS_A                          =
   (PT_STRING8) or (($3A29) shl 16);
const PR_BUSINESS_ADDRESS_STREET                   = PR_STREET_ADDRESS;
const PR_BUSINESS_ADDRESS_STREET_W                 = PR_STREET_ADDRESS_W;
const PR_BUSINESS_ADDRESS_STREET_A                 = PR_STREET_ADDRESS_A;

const PR_POSTAL_CODE                               = 
   (PT_TSTRING) or (($3A2A) shl 16);
const PR_POSTAL_CODE_W                             = 
   (PT_UNICODE) or (($3A2A) shl 16);
const PR_POSTAL_CODE_A                             = 
   (PT_STRING8) or (($3A2A) shl 16);
const PR_BUSINESS_ADDRESS_POSTAL_CODE              = PR_POSTAL_CODE;
const PR_BUSINESS_ADDRESS_POSTAL_CODE_W            = PR_POSTAL_CODE_W;
const PR_BUSINESS_ADDRESS_POSTAL_CODE_A            = PR_POSTAL_CODE_A;


const PR_POST_OFFICE_BOX                           = 
   (PT_TSTRING) or (($3A2) shl 16);
const PR_POST_OFFICE_BOX_W                         = 
   (PT_UNICODE) or (($3A2) shl 16);
const PR_POST_OFFICE_BOX_A                         = 
   (PT_STRING8) or (($3A2) shl 16);
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX          = PR_POST_OFFICE_BOX;
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX_W        = PR_POST_OFFICE_BOX_W;
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX_A        = PR_POST_OFFICE_BOX_A;


const PR_TELEX_NUMBER                              = 
   (PT_TSTRING) or (($3A2C) shl 16);
const PR_TELEX_NUMBER_W                            = 
   (PT_UNICODE) or (($3A2C) shl 16);
const PR_TELEX_NUMBER_A                            = 
   (PT_STRING8) or (($3A2C) shl 16);
const PR_ISDN_NUMBER                               = 
   (PT_TSTRING) or (($3A2D) shl 16);
const PR_ISDN_NUMBER_W                             = 
   (PT_UNICODE) or (($3A2D) shl 16);
const PR_ISDN_NUMBER_A                             = 
   (PT_STRING8) or (($3A2D) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER                = 
   (PT_TSTRING) or (($3A2E) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER_W              = 
   (PT_UNICODE) or (($3A2E) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER_A              = 
   (PT_STRING8) or (($3A2E) shl 16);
const PR_HOME2_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A2F) shl 16);
const PR_HOME2_TELEPHONE_NUMBER_W                  =
   (PT_UNICODE) or (($3A2F) shl 16);
const PR_HOME2_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A2F) shl 16);
const PR_ASSISTANT                                 = 
   (PT_TSTRING) or (($3A30) shl 16);
const PR_ASSISTANT_W                               = 
   (PT_UNICODE) or (($3A30) shl 16);
const PR_ASSISTANT_A                               = 
   (PT_STRING8) or (($3A30) shl 16);
const PR_SEND_RICH_INFO                            = 
   (PT_BOOLEAN) or (($3A40) shl 16);

const PR_WEDDING_ANNIVERSARY                       = 
   (PT_SYSTIME) or (($3A41) shl 16);
const PR_BIRTHDAY                                  = 
   (PT_SYSTIME) or (($3A42) shl 16);


const PR_HOBBIES                                   = 
   (PT_TSTRING) or (($3A43) shl 16);
const PR_HOBBIES_W                                 = 
   (PT_UNICODE) or (($3A43) shl 16);
const PR_HOBBIES_A                                 = 
   (PT_STRING8) or (($3A43) shl 16);

const PR_MIDDLE_NAME                               = 
   (PT_TSTRING) or (($3A44) shl 16);
const PR_MIDDLE_NAME_W                             = 
   (PT_UNICODE) or (($3A44) shl 16);
const PR_MIDDLE_NAME_A                             = 
   (PT_STRING8) or (($3A44) shl 16);

const PR_DISPLAY_NAME_PREFIX                       = 
   (PT_TSTRING) or (($3A45) shl 16);
const PR_DISPLAY_NAME_PREFIX_W                     = 
   (PT_UNICODE) or (($3A45) shl 16);
const PR_DISPLAY_NAME_PREFIX_A                     = 
   (PT_STRING8) or (($3A45) shl 16);

const PR_PROFESSION                                = 
   (PT_TSTRING) or (($3A46) shl 16);
const PR_PROFESSION_W                              = 
   (PT_UNICODE) or (($3A46) shl 16);
const PR_PROFESSION_A                              = 
   (PT_STRING8) or (($3A46) shl 16);

const PR_PREFERRED_BY_NAME                         = 
   (PT_TSTRING) or (($3A47) shl 16);
const PR_PREFERRED_BY_NAME_W                       = 
   (PT_UNICODE) or (($3A47) shl 16);
const PR_PREFERRED_BY_NAME_A                       = 
   (PT_STRING8) or (($3A47) shl 16);

const PR_SPOUSE_NAME                               = 
   (PT_TSTRING) or (($3A48) shl 16);
const PR_SPOUSE_NAME_W                             = 
   (PT_UNICODE) or (($3A48) shl 16);
const PR_SPOUSE_NAME_A                             = 
   (PT_STRING8) or (($3A48) shl 16);

const PR_COMPUTER_NETWORK_NAME                     = 
   (PT_TSTRING) or (($3A49) shl 16);
const PR_COMPUTER_NETWORK_NAME_W                   = 
   (PT_UNICODE) or (($3A49) shl 16);
const PR_COMPUTER_NETWORK_NAME_A                   = 
   (PT_STRING8) or (($3A49) shl 16);

const PR_CUSTOMER_ID                               = 
   (PT_TSTRING) or (($3A4A) shl 16);
const PR_CUSTOMER_ID_W                             = 
   (PT_UNICODE) or (($3A4A) shl 16);
const PR_CUSTOMER_ID_A                             =
   (PT_STRING8) or (($3A4A) shl 16);

const PR_TTYTDD_PHONE_NUMBER                       = 
   (PT_TSTRING) or (($3A4) shl 16);
const PR_TTYTDD_PHONE_NUMBER_W                     =
   (PT_UNICODE) or (($3A4) shl 16);
const PR_TTYTDD_PHONE_NUMBER_A                     = 
   (PT_STRING8) or (($3A4) shl 16);

const PR_FTP_SITE                                  = 
   (PT_TSTRING) or (($3A4C) shl 16);
const PR_FTP_SITE_W                                = 
   (PT_UNICODE) or (($3A4C) shl 16);
const PR_FTP_SITE_A                                = 
   (PT_STRING8) or (($3A4C) shl 16);

const PR_GENDER                                    = 
   (PT_SHORT) or (($3A4D) shl 16);

const PR_MANAGER_NAME                              = 
   (PT_TSTRING) or (($3A4E) shl 16);
const PR_MANAGER_NAME_W                            = 
   (PT_UNICODE) or (($3A4E) shl 16);
const PR_MANAGER_NAME_A                            =
   (PT_STRING8) or (($3A4E) shl 16);

const PR_NICKNAME                                  = 
   (PT_TSTRING) or (($3A4F) shl 16);
const PR_NICKNAME_W                                =
   (PT_UNICODE) or (($3A4F) shl 16);
const PR_NICKNAME_A                                = 
   (PT_STRING8) or (($3A4F) shl 16);

const PR_PERSONAL_HOME_PAGE                        = 
   (PT_TSTRING) or (($3A50) shl 16);
const PR_PERSONAL_HOME_PAGE_W                      = 
   (PT_UNICODE) or (($3A50) shl 16);
const PR_PERSONAL_HOME_PAGE_A                      = 
   (PT_STRING8) or (($3A50) shl 16);


const PR_BUSINESS_HOME_PAGE                        = 
   (PT_TSTRING) or (($3A51) shl 16);
const PR_BUSINESS_HOME_PAGE_W                      = 
   (PT_UNICODE) or (($3A51) shl 16);
const PR_BUSINESS_HOME_PAGE_A                      = 
   (PT_STRING8) or (($3A51) shl 16);

const PR_CONTACT_VERSION                           = 
   (PT_CLSID) or (($3A52) shl 16);
const PR_CONTACT_ENTRYIDS                          = 
   (PT_MV_BINARY) or (($3A53) shl 16);

const PR_CONTACT_ADDRTYPES                         = 
   (PT_MV_TSTRING) or (($3A54) shl 16);
const PR_CONTACT_ADDRTYPES_W                       = 
   (PT_MV_UNICODE) or (($3A54) shl 16);
const PR_CONTACT_ADDRTYPES_A                       = 
   (PT_MV_STRING8) or (($3A54) shl 16);

const PR_CONTACT_DEFAULT_ADDRESS_INDEX             = 
   (PT_LONG) or (($3A55) shl 16);

const PR_CONTACT_EMAIL_ADDRESSES                   = 
   (PT_MV_TSTRING) or (($3A56) shl 16);
const PR_CONTACT_EMAIL_ADDRESSES_W                 = 
   (PT_MV_UNICODE) or (($3A56) shl 16);
const PR_CONTACT_EMAIL_ADDRESSES_A                 = 
   (PT_MV_STRING8) or (($3A56) shl 16);


const PR_COMPANY_MAIN_PHONE_NUMBER                 =
   (PT_TSTRING) or (($3A57) shl 16);
const PR_COMPANY_MAIN_PHONE_NUMBER_W               = 
   (PT_UNICODE) or (($3A57) shl 16);
const PR_COMPANY_MAIN_PHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A57) shl 16);

const PR_CHILDRENS_NAMES                           = 
   (PT_MV_TSTRING) or (($3A58) shl 16);
const PR_CHILDRENS_NAMES_W                         = 
   (PT_MV_UNICODE) or (($3A58) shl 16);
const PR_CHILDRENS_NAMES_A                         = 
   (PT_MV_STRING8) or (($3A58) shl 16);



const PR_HOME_ADDRESS_CITY                         = 
   (PT_TSTRING) or (($3A59) shl 16);
const PR_HOME_ADDRESS_CITY_W                       = 
   (PT_UNICODE) or (($3A59) shl 16);
const PR_HOME_ADDRESS_CITY_A                       = 
   (PT_STRING8) or (($3A59) shl 16);

const PR_HOME_ADDRESS_COUNTRY                      = 
   (PT_TSTRING) or (($3A5A) shl 16);
const PR_HOME_ADDRESS_COUNTRY_W                    = 
   (PT_UNICODE) or (($3A5A) shl 16);
const PR_HOME_ADDRESS_COUNTRY_A                    = 
   (PT_STRING8) or (($3A5A) shl 16);

const PR_HOME_ADDRESS_POSTAL_CODE                  = 
   (PT_TSTRING) or (($3A5) shl 16);
const PR_HOME_ADDRESS_POSTAL_CODE_W                = 
   (PT_UNICODE) or (($3A5) shl 16);
const PR_HOME_ADDRESS_POSTAL_CODE_A                = 
   (PT_STRING8) or (($3A5) shl 16);

const PR_HOME_ADDRESS_STATE_OR_PROVINCE            = 
   (PT_TSTRING) or (($3A5C) shl 16);
const PR_HOME_ADDRESS_STATE_OR_PROVINCE_W          = 
   (PT_UNICODE) or (($3A5C) shl 16);
const PR_HOME_ADDRESS_STATE_OR_PROVINCE_A          = 
   (PT_STRING8) or (($3A5C) shl 16);

const PR_HOME_ADDRESS_STREET                       = 
   (PT_TSTRING) or (($3A5D) shl 16);
const PR_HOME_ADDRESS_STREET_W                     = 
   (PT_UNICODE) or (($3A5D) shl 16);
const PR_HOME_ADDRESS_STREET_A                     =
   (PT_STRING8) or (($3A5D) shl 16);

const PR_HOME_ADDRESS_POST_OFFICE_BOX              = 
   (PT_TSTRING) or (($3A5E) shl 16);
const PR_HOME_ADDRESS_POST_OFFICE_BOX_W            =
   (PT_UNICODE) or (($3A5E) shl 16);
const PR_HOME_ADDRESS_POST_OFFICE_BOX_A            = 
   (PT_STRING8) or (($3A5E) shl 16);

const PR_OTHER_ADDRESS_CITY                        = 
   (PT_TSTRING) or (($3A5F) shl 16);
const PR_OTHER_ADDRESS_CITY_W                      = 
   (PT_UNICODE) or (($3A5F) shl 16);
const PR_OTHER_ADDRESS_CITY_A                      = 
   (PT_STRING8) or (($3A5F) shl 16);

const PR_OTHER_ADDRESS_COUNTRY                     = 
   (PT_TSTRING) or (($3A60) shl 16);
const PR_OTHER_ADDRESS_COUNTRY_W                   = 
   (PT_UNICODE) or (($3A60) shl 16);
const PR_OTHER_ADDRESS_COUNTRY_A                   = 
   (PT_STRING8) or (($3A60) shl 16);

const PR_OTHER_ADDRESS_POSTAL_CODE                 =
   (PT_TSTRING) or (($3A61) shl 16);
const PR_OTHER_ADDRESS_POSTAL_CODE_W               = 
   (PT_UNICODE) or (($3A61) shl 16);
const PR_OTHER_ADDRESS_POSTAL_CODE_A               = 
   (PT_STRING8) or (($3A61) shl 16);

const PR_OTHER_ADDRESS_STATE_OR_PROVINCE           = 
   (PT_TSTRING) or (($3A62) shl 16);
const PR_OTHER_ADDRESS_STATE_OR_PROVINCE_W         = 
   (PT_UNICODE) or (($3A62) shl 16);
const PR_OTHER_ADDRESS_STATE_OR_PROVINCE_A         = 
   (PT_STRING8) or (($3A62) shl 16);

const PR_OTHER_ADDRESS_STREET                      = 
   (PT_TSTRING) or (($3A63) shl 16);
const PR_OTHER_ADDRESS_STREET_W                    = 
   (PT_UNICODE) or (($3A63) shl 16);
const PR_OTHER_ADDRESS_STREET_A                    = 
   (PT_STRING8) or (($3A63) shl 16);

const PR_OTHER_ADDRESS_POST_OFFICE_BOX             = 
   (PT_TSTRING) or (($3A64) shl 16);
const PR_OTHER_ADDRESS_POST_OFFICE_BOX_W           = 
   (PT_UNICODE) or (($3A64) shl 16);
const PR_OTHER_ADDRESS_POST_OFFICE_BOX_A           = 
   (PT_STRING8) or (($3A64) shl 16);


(*
 *  Profile section properties
 *)

const PR_STORE_PROVIDERS                           = 
   (PT_BINARY) or (($3D00) shl 16);
const PR_AB_PROVIDERS                              = 
   (PT_BINARY) or (($3D01) shl 16);
const PR_TRANSPORT_PROVIDERS                       = 
   (PT_BINARY) or (($3D02) shl 16);

const PR_DEFAULT_PROFILE                           = 
   (PT_BOOLEAN) or (($3D04) shl 16);
const PR_AB_SEARCH_PATH                            = 
   (PT_MV_BINARY) or (($3D05) shl 16);
const PR_AB_DEFAULT_DIR                            = 
   (PT_BINARY) or (($3D06) shl 16);
const PR_AB_DEFAULT_PAB                            = 
   (PT_BINARY) or (($3D07) shl 16);

const PR_FILTERING_HOOKS                           = 
   (PT_BINARY) or (($3D08) shl 16);
const PR_SERVICE_NAME                              = 
   (PT_TSTRING) or (($3D09) shl 16);
const PR_SERVICE_NAME_W                            =
   (PT_UNICODE) or (($3D09) shl 16);
const PR_SERVICE_NAME_A                            = 
   (PT_STRING8) or (($3D09) shl 16);
const PR_SERVICE_DLL_NAME                          = 
   (PT_TSTRING) or (($3D0A) shl 16);
const PR_SERVICE_DLL_NAME_W                        = 
   (PT_UNICODE) or (($3D0A) shl 16);
const PR_SERVICE_DLL_NAME_A                        = 
   (PT_STRING8) or (($3D0A) shl 16);
const PR_SERVICE_ENTRY_NAME                        = 
   (PT_STRING8) or (($3D0) shl 16);
const PR_SERVICE_UID                               = 
   (PT_BINARY) or (($3D0C) shl 16);
const PR_SERVICE_EXTRA_UIDS                        = 
   (PT_BINARY) or (($3D0D) shl 16);
const PR_SERVICES                                  = 
   (PT_BINARY) or (($3D0E) shl 16);
const PR_SERVICE_SUPPORT_FILES                     = 
   (PT_MV_TSTRING) or (($3D0F) shl 16);
const PR_SERVICE_SUPPORT_FILES_W                   = 
   (PT_MV_UNICODE) or (($3D0F) shl 16);
const PR_SERVICE_SUPPORT_FILES_A                   = 
   (PT_MV_STRING8) or (($3D0F) shl 16);
const PR_SERVICE_DELETE_FILES                      =
   (PT_MV_TSTRING) or (($3D10) shl 16);
const PR_SERVICE_DELETE_FILES_W                    = 
   (PT_MV_UNICODE) or (($3D10) shl 16);
const PR_SERVICE_DELETE_FILES_A                    = 
   (PT_MV_STRING8) or (($3D10) shl 16);
const PR_AB_SEARCH_PATH_UPDATE                     = 
   (PT_BINARY) or (($3D11) shl 16);
const PR_PROFILE_NAME                              = 
   (PT_TSTRING) or (($3D12) shl 16);
const PR_PROFILE_NAME_A                            = 
   (PT_STRING8) or (($3D12) shl 16);
const PR_PROFILE_NAME_W                            = 
   (PT_UNICODE) or (($3D12) shl 16);

(*
 *  Status object properties
 *)

const PR_IDENTITY_DISPLAY                          =
   (PT_TSTRING) or (($3E00) shl 16);
const PR_IDENTITY_DISPLAY_W                        = 
   (PT_UNICODE) or (($3E00) shl 16);
const PR_IDENTITY_DISPLAY_A                        = 
   (PT_STRING8) or (($3E00) shl 16);
const PR_IDENTITY_ENTRYID                          = 
   (PT_BINARY) or (($3E01) shl 16);
const PR_RESOURCE_METHODS                          = 
   (PT_LONG) or (($3E02) shl 16);
const PR_RESOURCE_TYPE                             = 
   (PT_LONG) or (($3E03) shl 16);
const PR_STATUS_CODE                               = 
   (PT_LONG) or (($3E04) shl 16);
const PR_IDENTITY_SEARCH_KEY                       = 
   (PT_BINARY) or (($3E05) shl 16);
const PR_OWN_STORE_ENTRYID                         = 
   (PT_BINARY) or (($3E06) shl 16);
const PR_RESOURCE_PATH                             = 
   (PT_TSTRING) or (($3E07) shl 16);
const PR_RESOURCE_PATH_W                           = 
   (PT_UNICODE) or (($3E07) shl 16);
const PR_RESOURCE_PATH_A                           = 
   (PT_STRING8) or (($3E07) shl 16);
const PR_STATUS_STRING                             =
   (PT_TSTRING) or (($3E08) shl 16);
const PR_STATUS_STRING_W                           = 
   (PT_UNICODE) or (($3E08) shl 16);
const PR_STATUS_STRING_A                           = 
   (PT_STRING8) or (($3E08) shl 16);
const PR_X400_DEFERRED_DELIVERY_CANCEL             = 
   (PT_BOOLEAN) or (($3E09) shl 16);
const PR_HEADER_FOLDER_ENTRYID                     = 
   (PT_BINARY) or (($3E0A) shl 16);
const PR_REMOTE_PROGRESS                           = 
   (PT_LONG) or (($3E0) shl 16);
const PR_REMOTE_PROGRESS_TEXT                      = 
   (PT_TSTRING) or (($3E0C) shl 16);
const PR_REMOTE_PROGRESS_TEXT_W                    = 
   (PT_UNICODE) or (($3E0C) shl 16);
const PR_REMOTE_PROGRESS_TEXT_A                    = 
   (PT_STRING8) or (($3E0C) shl 16);
const PR_REMOTE_VALIDATE_OK                        = 
   (PT_BOOLEAN) or (($3E0D) shl 16);

(*
 * Display table properties
 *)

const PR_CONTROL_FLAGS                             = 
   (PT_LONG) or (($3F00) shl 16);
const PR_CONTROL_STRUCTURE                         = 
   (PT_BINARY) or (($3F01) shl 16);
const PR_CONTROL_TYPE                              =
   (PT_LONG) or (($3F02) shl 16);
const PR_DELTAX                                    = 
   (PT_LONG) or (($3F03) shl 16);
const PR_DELTAY                                    = 
   (PT_LONG) or (($3F04) shl 16);
const PR_XPOS                                      = 
   (PT_LONG) or (($3F05) shl 16);
const PR_YPOS                                      = 
   (PT_LONG) or (($3F06) shl 16);
const PR_CONTROL_ID                                = 
   (PT_BINARY) or (($3F07) shl 16);
const PR_INITIAL_DETAILS_PANE                      =
   (PT_LONG) or (($3F08) shl 16);

(*
 * Secure property id range
 *)

const PROP_ID_SECURE_MIN                           = $67F0;
const PROP_ID_SECURE_MAX                           = $67FF;

implementation

end.

